Package: iSEEtree
Version: 1.6.0
Authors@R: 
    c(person(given = "Giulio", family = "Benedetti", role = c("aut", "cre"),
           email = "giulio.benedetti@utu.fi",
           comment = c(ORCID = "0000-0002-8732-7692")),
      person(given = "Ely", family = "Seraidarian", role = c("ctb"),
             email = "ely.seraidarian@utu.fi",
             comment = c(ORCID = "0009-0008-8602-093X")),
      person(given = "Leo", family = "Lahti", role = c("aut"),
             email = "leo.lahti@iki.fi",
             comment = c(ORCID = "0000-0001-5537-637X")))
Title: Interactive visualisation for microbiome data
Description: 
    iSEEtree is an extension of iSEE for the TreeSummarizedExperiment data
    container. It provides interactive panel designs to explore hierarchical
    datasets, such as the microbiome and cell lines.
biocViews: Software, Visualization, Microbiome, GUI, ShinyApps,
        DataImport
License: Artistic-2.0
Encoding: UTF-8
Depends: R (>= 4.4.0), iSEE (>= 2.19.4)
Imports: ape, ggplot2, ggtree, grDevices, methods, miaViz, purrr,
        S4Vectors, shiny, mia, shinyWidgets, SingleCellExperiment,
        SummarizedExperiment, tidygraph, TreeSummarizedExperiment,
        utils
Suggests: biomformat, BiocStyle, knitr, RefManageR, remotes, rmarkdown,
        scater, testthat (>= 3.0.0), vegan
URL: https://github.com/microbiome/iSEEtree
BugReports: https://github.com/microbiome/iSEEtree/issues
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/iSEEtree
git_branch: RELEASE_3_23
git_last_commit: 7bf7989
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:49:51 UTC; biocbuild
Author: Giulio Benedetti [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8732-7692>),
  Ely Seraidarian [ctb] (ORCID: <https://orcid.org/0009-0008-8602-093X>),
  Leo Lahti [aut] (ORCID: <https://orcid.org/0000-0001-5537-637X>)
Maintainer: Giulio Benedetti <giulio.benedetti@utu.fi>

# iSEEtree

[![issues](https://img.shields.io/github/issues/microbiome/iSEEtree)](https://github.com/microbiome/iSEEtree/issues)
[![pulls](https://img.shields.io/github/issues-pr/microbiome/iSEEtree)](https://github.com/microbiome/iSEEtree/pulls)
[![R-CMD-check](https://github.com/microbiome/iSEEtree/workflows/rworkflows/badge.svg)](https://github.com/microbiome/iSEEtree/actions)
[![codecov](https://codecov.io/gh/microbiome/iSEEtree/branch/devel/graph/badge.svg)](https://app.codecov.io/gh/microbiome/iSEEtree?branch=devel)
[![codefactor](https://www.codefactor.io/repository/github/microbiome/iseetree/badge)](https://www.codefactor.io/repository/github/microbiome/iseetree)

The goal of iSEEtree is to provide panel designs to explore hierarchical data
stored in TreeSummarizedExperiment objects. This enables the interactive
visualisation of microbiome data, cell lines and more.

## Installation instructions

The release version of iSEEtree can be installed from Bioconductor as follows:

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("iSEEtree")
```

Contributors or users interested in the latest functionality can install the
devel version of iSEEtree as follows:

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following initializes usage of Bioc devel
BiocManager::install(version='devel')

BiocManager::install("iSEEtree")
```

## Example

The basic functionality of iSEEtree can be explored as follows:

```
library(iSEEtree)
library(mia)
library(scater)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Add reduced dimensions
tse <- runMDS(tse, assay.type = "relabundance")

# Launch iSEE
if (interactive()) {
  iSEE(tse)
}
```

## Code of Conduct
Please note that the iSEEtree project is released with a
[Contributor Code of Conduct](https://bioconductor.org/about/code-of-conduct/).
By contributing to this project, you agree to abide by its terms. Contributions
are welcome in the form of feedback, issues and pull requests. You can find the
contributor guidelines of the miaverse
[here](https://github.com/microbiome/mia/blob/devel/CONTRIBUTING.md).

## Acknowledgements

iSEEtree originates from the joint effort of the R/Bioconductor community. It is
mainly based on the following software:

- [R](https://www.r-project.org/), statistical programming language [@core2024r]
- [mia](https://bioconductor.org/packages/release/bioc/html/mia.html), framework for microbiome data analysis [@borman2024mia]
- [iSEE](https://bioconductor.org/packages/release/bioc/html/iSEE.html), SummarizedExperiment interactive explorer [@rue2018isee]
- [TreeSummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/TreeSummarizedExperiment.htmlm), S4 container for hierarchical data [@huang2021treesummarizedexperiment]
- [shiny](https://cran.r-project.org/web/packages/shiny/index.html), web app development in R [@chang2024shiny]

#' Scree plot
#'
#' Contribution of each reduced dimension component to explained variance. The
#' reduced dimension should be stored in the
#' \code{\link[SingleCellExperiment:reducedDims]{reducedDim}} slot of a
#' \code{\link[SingleSummarizedExperiment:SingleSummarizedExperiment-class]{SingleSummarizedExperiment}}.
#' This panel uses \code{\link[miaViz:plotScree]{plotScree}} to generate the
#' plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{dimred} \code{Character scalar} or \code{integer scalar}.
#'   Determines the reduced dimension to plot. This is used when \code{x} is a
#'   \code{TreeSummarizedExperiment} to extract the eigenvalues from
#'   \code{reducedDim(x, dimred)}.
#'
#' \item \code{show.barplot}: \code{Logical scalar}. Whether to show a barplot.
#'   (Default: \code{TRUE})
#'
#' \item \code{show.points}: \code{Logical scalar}. Whether to show points.
#'   (Default: \code{TRUE})
#'
#' \item \code{show.line}: \code{Logical scalar}. Whether to show lines.
#'   (Default: \code{TRUE})
#'
#' \item \code{show.labels}: \code{Logical scalar}. Whether to show a label for
#'   each point. (Default: \code{FALSE})
#'
#' \item \code{add.proportion}: \code{Logical scalar}. Whether to show proportion of
#'   explained variance, i.e., raw eigenvalues. (Default: \code{TRUE})
#'
#' \item \code{add.cumulative}: \code{Logical scalar}. Whether to show cumulative
#'   explained variance calculated from eigenvalues. (Default: \code{FALSE})
#'
#' \item \code{n}: \code{Integer scalar}. Number of eigenvalues to plot. If
#'   unspecified, all eigenvalues are plotted. (Default: \code{NULL})
#'
#' \item \code{show.names}: \code{Logical scalar}. Whether to show names of the
#'    components on the x-axis. If \code{FALSE}, indices are shown instead.
#'    (Default: \code{FALSE})
#'
#' \item \code{eig.name}: \code{Character scalar}. The name of the attribute in
#'   \code{reducedDim(x, dimred)} that contains the eigenvalues.
#'   (Default: \code{c("eig", "varExplained")})
#' }
#' 
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{ScreePlot(...)} constructor creates an instance of an ScreePlot
#' class, where any slot and its value can be passed to \code{...} as a named
#' argument.
#'
#' @examples
#' # Import libraries
#' library(mia)
#' library(scater)
#' 
#' # Import TreeSE
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' # Add relabundance assay
#' tse <- transformAssay(tse, method = "relabundance")
#' 
#' # Add reduced dimensions
#' tse <- runPCA(tse, assay.type = "relabundance")
#'
#' # Store panel into object
#' panel <- ScreePlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @seealso
#' \linkS4class{LoadingPlot}
#' \linkS4class{RDAPlot}
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name ScreePlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("ScreePlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("dimred", "eig.name"))
    msg <- .validNumberError(msg, x, "n", lower=1, upper=Inf)
    msg <- .validLogicalError(msg, x, fields=c("show.barplot", "show.points",
        "show.line", "show.labels", "add.proportion", "add.cumulative",
        "show.names"))

    if( length(msg) ){
        return(msg)
    }
    
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "ScreePlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "dimred", "PCA")
    args <- .emptyDefault(args, "show.barplot", TRUE)
    args <- .emptyDefault(args, "show.line", TRUE)
    args <- .emptyDefault(args, "show.labels", FALSE)
    args <- .emptyDefault(args, "add.proportion", TRUE)
    args <- .emptyDefault(args, "add.cumulative", FALSE)
    args <- .emptyDefault(args, "n", 5)
    args <- .emptyDefault(args, "show.names", FALSE)
    args <- .emptyDefault(args, "show.points", TRUE)
    args <- .emptyDefault(args, "eig.name", NA_character_)
    
    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
ScreePlot <- function(...) {
    new("ScreePlot", ...)
}

#' @importFrom methods slot
#' @importFrom SingleCellExperiment reducedDim reducedDimNames
setMethod(".defineDataInterface", "ScreePlot",
    function(x, se, select_info) {
    
    panel_name <- .getEncodedName(x)
    
    list(.selectInput.iSEE(x, field="dimred", label="Reduced dimension:",
            choices=reducedDimNames(se), selected=slot(x, "dimred")),
        # Number of components
        .numericInput.iSEE(x, field="n", label="Number of components:",
            value=slot(x, "n"), min=1, step=1,
            max=ncol(reducedDim(se, slot(x, "dimred")))),
        .checkboxInput.iSEE(x, field="show.barplot", label="Show barplot",
            value=slot(x, "show.barplot")),
        .checkboxInput.iSEE(x, field="add.proportion", label="Add proportion",
            value=slot(x, "add.proportion")),
        .checkboxInput.iSEE(x, field="add.cumulative", label="Add cumulative",
            value=slot(x, "add.cumulative")))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "ScreePlot",
    function(x, se, select_info) {
    
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_scree_plot(x, se))
})

setMethod(".createObservers", "ScreePlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name, c("dimred", "n",
        "show.barplot", "show.points", "show.line"), input=input,
        pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("show.labels",
        "add.proportion", "add.cumulative", "show.names"), input=input,
        pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "ScreePlot", function(x) "Scree plot")
setMethod(".panelColor", "ScreePlot", function(x) "#0066CC")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "ScreePlot", function(x) {
    plot_name <- .getEncodedName(x)
    
    addSpinner(
        plotOutput(plot_name, height = paste0(slot(x, "PanelHeight"), "px")),
        color=.panelColor(x))
})

#' @importFrom miaViz plotScree
setMethod(".generateOutput", "ScreePlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    args[["dimred"]] <- deparse(slot(x, "dimred"))
    args[["show.barplot"]] <- deparse(slot(x , "show.barplot"))
    args[["show.points"]] <- deparse(slot(x , "show.points"))
    args[["show.line"]] <- deparse(slot(x , "show.line"))
    args[["add.proportion"]] <- deparse(slot(x , "add.proportion"))
    args[["add.cumulative"]] <- deparse(slot(x , "add.cumulative"))
    args[["show.names"]] <- deparse(slot(x , "show.names"))
    args[["show.labels"]] <- deparse(slot(x , "show.labels"))
    
    if( is.na(slot(x, "n")) || slot(x, "n") <= 0 ){
        args[["n"]] <- 5
    } else if( slot(x, "n") > ncol(reducedDim(se, slot(x, "dimred"))) ){
        args[["n"]] <- ncol(reducedDim(se, slot(x, "dimred")))
    } else {
        args[["n"]] <- deparse(slot(x, "n"))
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotScree(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "ScreePlot",
            function(x, se, output, pObjects, rObjects) {
    
    plot_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[plot_name]] <- renderPlot({
        .retrieveOutput(plot_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "ScreePlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "ScreePlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">Scree Plot</font> panel
        contains a representation of the taxa contributions to the target
        reduced dimensions.", .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
.create_visual_box_for_scree_plot <- function(x, se) {
    panel_name <- .getEncodedName(x)
    
    .addSpecificTour(class(x)[1], "show.points", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_show\\.points"), intro = "Here, we can choose
            whether or not to show the points.")))})
    .addSpecificTour(class(x)[1], "show.line", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_show\\.line"), intro = "Here, we can choose
            whether or not to connect the points with a line.")))})
    .addSpecificTour(class(x)[1], "show.labels", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_show\\.labels"), intro = "Here, we can choose
            whether or not to show the component labels.")))})
    .addSpecificTour(class(x)[1], "show.names", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_show\\.names"), intro = "Here, we can choose
            whether or not to show the component names.")))})
    
    collapseBox(
        paste0(panel_name, "_Visual"), title="Visual parameters", open=FALSE,
            list(.checkboxInput.iSEE(x, field="show.points",
                label="Show points", value=slot(x, "show.points")),
            .checkboxInput.iSEE(x, field="show.line", label="Show line",
                value=slot(x, "show.line")),
            .checkboxInput.iSEE(x, field="show.labels", label="Show labels",
                value=slot(x, "show.labels")),
            .checkboxInput.iSEE(x, field="show.names", label="Show names",
                value=slot(x, "show.names"))))
}

## ----include=FALSE------------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----install, eval=FALSE------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("iSEEtree")

## ----start, message=FALSE, warning=FALSE--------------------------------------
library(iSEEtree)
library(mia)
library(scater)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Add reduced dimensions
tse <- runMDS(tse, assay.type = "relabundance")

# Launch iSEE
if (interactive()) {
  iSEE(tse)
}

## ----screenfun, eval=!exists("SCREENSHOT"), include=FALSE---------------------
SCREENSHOT <- function(x, ...) knitr::include_graphics(x)

## ----screenplot, echo=FALSE, out.width="100%"---------------------------------
SCREENSHOT("screenshots/get_started.png", delay=20)

## ----citation-----------------------------------------------------------------
citation("iSEEtree")

## ----reproduce, echo=FALSE--------------------------------------------------------------------------------------------
## Session info
options(width = 120)
sessionInfo()

#' Abundance density plot
#'
#' Density abundance profile of single features in a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}.
#' The panel implements \code{\link[miaViz:plotAbundanceDensity]{plotAbundanceDensity}}
#' to generate the plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{layout}, a string specifying abundance layout (jitter, density or points). 
#' \item \code{assay.type}, a string specifying the assay to visualize.
#' \item \code{n}, a number indicating the number of top taxa to visualize.
#' \item \code{flipped}, a logical specifying if the axis should be switched.
#' \item \code{order_descending}, a string specifying the descending order.
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{AbundanceDensityPlot(...)} constructor creates an instance of an
#' AbundanceDensityPlot class, where any slot and its value can be passed to
#' \code{...} as a named argument.
#'
#' @author Giulio Benedetti
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' # Add relabundance assay
#' tse <- transformAssay(tse, method = "relabundance")
#'
#' # Store panel into object
#' panel <- AbundanceDensityPlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @docType methods
#' @name AbundanceDensityPlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("AbundanceDensityPlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("layout", "assay.type"))
    msg <- .validNumberError(msg, x, "n", lower=1, upper=Inf)
    msg <- .validLogicalError(msg, x, fields=c("add_legend", "flipped", "order_descending"))
    
    if( length(msg) ){
        return(msg)
    }
    
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "AbundanceDensityPlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "layout", "jitter")
    args <- .emptyDefault(args, "assay.type", "counts")
    args <- .emptyDefault(args, "n", 5)
    args <- .emptyDefault(args, "add_legend", TRUE)
    args <- .emptyDefault(args, "flipped", FALSE)
    args <- .emptyDefault(args, "dots_colour", "None")
    args <- .emptyDefault(args, "dots_shape", "None")
    args <- .emptyDefault(args, "dots_colour_by", NA_character_)
    args <- .emptyDefault(args, "dots_shape_by", NA_character_)
    args <- .emptyDefault(args, "order_descending", TRUE)
    
    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
AbundanceDensityPlot <- function(...) {
    new("AbundanceDensityPlot", ...)
}

#' @importFrom methods slot
#' @importFrom SummarizedExperiment assayNames
setMethod(".defineDataInterface", "AbundanceDensityPlot",
    function(x, se, select_info) {
    
    panel_name <- .getEncodedName(x)
    
    list(.selectInput.iSEE(x, field="assay.type", label="Assay type:",
            choices=assayNames(se), selected=slot(x, "assay.type")),
        # Number of taxa
        .numericInput.iSEE(x, field="n", label="Number of taxa:",
            value=slot(x, "n"), min=1, max=nrow(se), step=1),
        
        .checkboxInput.iSEE(x, field="flipped", label="Switch axes",
            value=slot(x, "flipped")),
        
        .checkboxInput.iSEE(x, field="order_descending", label="Order decreasing",
            value=slot(x, "order_descending")),
        
        .radioButtons.iSEE(
            x, field="dots_shape", label="Dot shape:", inline=TRUE,
            choices=c("None", "Column data"),
            selected=slot(x, "dots_shape")),
        
        .conditionalOnRadio(
            paste0(panel_name, "_dots_shape"), "Column data",
                .selectInput.iSEE(x, field="dots_shape_by",
                    label="Shape dots by", choices=names(colData(se)), 
                    selected=slot(x, "dots_shape_by"))))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "AbundanceDensityPlot",
    function(x, se, select_info) {
    
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_abunddens_plot(x, se), out[-1])
})

setMethod(".createObservers", "AbundanceDensityPlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name, c("layout", "assay.type",
       "n", "add_legend", "flipped", "order_descending"), input=input,
       pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name,
        c("dots_colour", "dots_colour_by", "dots_shape", "dots_shape_by"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "AbundanceDensityPlot", function(x) "Abundance density plot")
setMethod(".panelColor", "AbundanceDensityPlot", function(x) "#8B5A2B")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "AbundanceDensityPlot", function(x) {
    plot_name <- .getEncodedName(x)
    
    addSpinner(
        plotOutput(plot_name, height = paste0(slot(x, "PanelHeight"), "px")),
        color=.panelColor(x))
})

#' @importFrom miaViz plotAbundanceDensity
setMethod(".generateOutput", "AbundanceDensityPlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )
    
    if( exists("row_selected", envir=panel_env, inherits=FALSE) ){
        panel_env[["se"]] <- se[unlist(panel_env[["row_selected"]]), ]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["layout"]] <- deparse(slot(x, "layout"))
    args[["add_legend"]] <- deparse(slot(x, "add_legend"))
    args[["assay.type"]] <- deparse(slot(x, "assay.type"))
    args[["flipped"]] <- deparse(slot(x , "flipped"))
    args[["order_descending"]] <- deparse(slot(x, "order_descending"))
    
    if( is.na(slot(x, "n")) || slot(x, "n") <= 0 ){
        args[["n"]] <- 5
    } else if( slot(x, "n") > nrow(se) ){
        args[["n"]] <- nrow(se)
    } else {
        args[["n"]] <- deparse(slot(x, "n"))
    }
    
    if( slot(x, "dots_colour") == "Column data" ){
        args[["colour_by"]] <- deparse(slot(x, "dots_colour_by"))
    }
    
    if (slot(x, "dots_shape") == "Column data") {
        args[["shape_by"]] <- deparse(slot(x, "dots_shape_by"))
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotAbundanceDensity(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "AbundanceDensityPlot",
            function(x, se, output, pObjects, rObjects) {
    
    plot_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[plot_name]] <- renderPlot({
        .retrieveOutput(plot_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "AbundanceDensityPlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "AbundanceDensityPlot", function(x, field) {
    
    if ( field %in% c("SelectionHistory", "ColumnSelectionRestrict",
                    "ColumnSelectionDynamicSource", "ColumnSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "AbundanceDensityPlot",
    function(x, dim = character(0)) {
    
    if ("row" %in% dim) {
        return(TRUE)
    }
    
    return(FALSE)
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "AbundanceDensityPlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">Abundance Density Plot</font> panel
        contains a representation of the abundance density 
        (i.e. most abundant taxa).", .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
#' @importFrom SummarizedExperiment colData
.create_visual_box_for_abunddens_plot <- function(x, se) {
    
    panel_name <- .getEncodedName(x)
    
    .addSpecificTour(class(x)[1], "layout", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_layout + .selectize-control"), intro = "Here, we can select the
            layout of the plot.")))})
    .addSpecificTour(class(x)[1], "add_legend", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add_legend"), intro = "Here, we can choose
            whether or not to show a legend.")))})
    .addSpecificTour(class(x)[1], "dots_colour", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_dots_colour"), intro = "Here, we can choose
            whether or not to show colors.")))})
    .addSpecificTour(class(x)[1], "dots_colour_by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_dots_colour_by + .selectize-control"), intro = "Here, we can choose
            the way you want to map the colors.")))})
    .addSpecificTour(class(x)[1], "assay.type", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_assay\\.type + .selectize-control"), intro = "Here, we can choose
            the assay to be transformed.")))})
    .addSpecificTour(class(x)[1], "n", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_n"), intro = "Here, we can choose
            the number of taxa to be selected.")))})
    .addSpecificTour(class(x)[1], "flipped", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_flipped"), intro = "Here, we can choose
            whether or not to switch the axis.")))})
    .addSpecificTour(class(x)[1], "order_descending", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_order_descending"), intro = "Here, we can choose
            whether or not to use descending order.
            If NA uses the order found in the <code>SummarizedExperiment</code>
            object.")))})
    .addSpecificTour(class(x)[1], "dots_shape", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_dots_shape"), intro = "Here, we can choose
            whether or not to change points shape.")))})
    .addSpecificTour(class(x)[1], "dots_shape_by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_dots_shape_by"), intro = "Here, we can choose
            to group by the different point shape groups.")))})
    
    # Define what parameters the user can adjust
    collapseBox(
        paste0(panel_name, "_Visual"), title="Visual parameters", open=FALSE,
            # Tree layout
            .selectInput.iSEE(x, field="layout", label="Layout",
                choices=c("jitter", "density", "point"),
                selected=slot(x, "layout")),
            # Colour legend
            .checkboxInput.iSEE(x, field="add_legend", label="View legend",
                value=slot(x, "add_legend")),
            .radioButtons.iSEE(
                x, field="dots_colour", label="Dot color:", inline=TRUE,
                choices=c("None", "Column data"),
                selected=slot(x, "dots_colour")),
            .conditionalOnRadio(
                paste0(panel_name, "_dots_colour"), "Column data",
                    .selectInput.iSEE(x, field="dots_colour_by",
                        label="Color dots by", choices=names(colData(se)), 
                        selected=slot(x, "dots_colour_by"))))
}

test_that("AbundanceDensityPlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  panel <- AbundanceDensityPlot()
  
  expect_identical(.getEncodedName(panel), "AbundanceDensityPlotNA")
  expect_identical(.fullName(panel), "Abundance density plot")
  expect_identical(.panelColor(panel), "#8B5A2B")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 6)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
    "p <- miaViz::plotAbundanceDensity(se, layout=\"jitter\", add_legend=TRUE,\n    assay.type=\"counts\", flipped=FALSE, order_descending=TRUE, n=5)",
    fixed = TRUE)
  
  expect_true(.hideInterface(panel, "ColumnSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "column"))
  expect_true(.multiSelectionResponsive(panel, "row"))
  
  expect_contains(slotNames(panel),
                  c("layout", "assay.type", "n", "dots_colour",
                    "dots_colour_by", "add_legend", "flipped",
                    "order_descending", "dots_shape", "dots_shape_by"))
  
  expect_contains(.definePanelTour(panel)[[1]],
                  c("#AbundanceDensityPlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_abunddens_plot(panel, tse),
                  "shiny.tag.list")

  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$AbundanceDensityPlotNA, "shiny.render.function")
  expect_s3_class(output$AbundanceDensityPlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$AbundanceDensityPlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")

  expect_identical(.exportOutput(panel, tse), "AbundanceDensityPlotNA.pdf")
  
})

test_that("iSEEtree", {
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  
  panels <- c(RowDataTable(), ColumnDataTable(), RowTreePlot(),
              AbundancePlot(), AbundanceDensityPlot(),
              ReducedDimensionPlot(), ComplexHeatmapPlot())

  expect_warning(
    panels <- .check_panel(tse, panels, "ReducedDimensionPlot", reducedDims),
    "no valid reducedDims fields for ReducedDimensionPlot"
  )
  
  expect_no_error(iSEE(tse, initial = panels))
  
})

#' Abundance plot
#'
#' Composite abundance profile of all features in a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' object. The panel implements \code{\link[miaViz:plotAbundance]{plotAbundance}}
#' to generate the plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualization:
#' \itemize{
#' \item \code{rank}, a string specifying the taxonomic rank to visualize.
#' \item \code{use_relative}, a logical indicating if the relative values should be calculated. 
#' \item \code{add_legend}, a logical indicating if the color legend should appear.
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{AbundancePlot(...)} constructor creates an instance of an
#' AbundancePlot class, where any slot and its value can be passed to \code{...}
#' as a named argument.
#'
#' @author Giulio Benedetti
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' # Store panel into object
#' panel <- AbundancePlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#' 
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @docType methods
#' @name AbundancePlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("AbundancePlot", function(x) {
    
    msg <- character(0)
    msg <- .singleStringError(msg, x, fields="rank")
    msg <- .validLogicalError(msg, x, fields=c("add_legend", "use_relative"))
    
    if( length(msg) ){
        return(msg)
    }
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "AbundancePlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "rank", NA_character_)
    args <- .emptyDefault(args, "order_sample_by_row", NA_character_)
    args <- .emptyDefault(args, "order_sample_by_column", NA_character_)
    args <- .emptyDefault(args, "add_legend", TRUE)
    args <- .emptyDefault(args, "use_relative", TRUE)
    args <- .emptyDefault(args, "decreasing", FALSE)
    args <- .emptyDefault(args, "order_sample", "None")
    
    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
AbundancePlot <- function(...) {
    new("AbundancePlot", ...)
}

#' @importFrom methods slot
#' @importFrom SummarizedExperiment colData
setMethod(".defineDataInterface", "AbundancePlot", function(x, se, select_info) {
    panel_name <- .getEncodedName(x)
          
    list(.checkboxInput.iSEE(x, field="use_relative",
        label="Use relative values", value=slot(x, "use_relative")),
        .radioButtons.iSEE(x, field="order_sample", label="Sample order:",
            inline=TRUE, choices=c("None", "Column data", "Row data"),
            selected=slot(x, "order_sample")),
            .conditionalOnRadio(paste0(panel_name, "_order_sample"), "Column data",
                list(.selectInput.iSEE(x, field="order_sample_by_column",
                label="Order sample by", choices=names(colData(se)),
                selected=slot(x, "order_sample_by_column")),
                .checkboxInput.iSEE(x, field="decreasing",
                label="Order decreasing", value=slot(x, "decreasing")))),
            .conditionalOnRadio(paste0(panel_name, "_order_sample"), "Row data",
                list(.selectInput.iSEE(x, field="order_sample_by_row",
                label="Order sample by", selected=slot(x, "order_sample_by_row"),
                choices=.list_taxa(se)),
                .checkboxInput.iSEE(x, field="decreasing",
                label="Order decreasing", value=slot(x, "decreasing")))))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "AbundancePlot", function(x, se, select_info) {
     
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_abund_plot(x, se), out[-1])
})

setMethod(".createObservers", "AbundancePlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name, c("rank", "use_relative",
        "add_legend"), input=input, pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("decreasing",
        "order_sample", "order_sample_by_row", "order_sample_by_column"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "AbundancePlot", function(x) "Abundance plot")
setMethod(".panelColor", "AbundancePlot", function(x) "#00E5EE")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "AbundancePlot", function(x) {
    panel_name <- .getEncodedName(x)
    
    addSpinner(plotOutput(panel_name,
        height = paste0(slot(x, "PanelHeight"), "px")), color=.panelColor(x))
})

#' @importFrom miaViz plotAbundance
setMethod(".generateOutput", "AbundancePlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )
    
    if( exists("col_selected", envir=panel_env, inherits=FALSE) ){
        panel_env[["se"]] <- se[ , unlist(panel_env[["col_selected"]])]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["rank"]] <- deparse(slot(x, "rank"))
    args[["add_legend"]] <- deparse(slot(x, "add_legend"))
    args[["use_relative"]] <- deparse(slot(x, "use_relative"))
    
    if( slot(x, "order_sample") == "Column data" ){
        args[["order_sample_by"]] <- deparse(slot(x, "order_sample_by_column"))
        args[["decreasing"]] <- deparse(slot(x, "decreasing"))
    }

    if( slot(x, "order_sample") == "Row data" &&
        slot(x, "order_sample_by_row") %in% .list_taxa(se)[[slot(x, "rank")]] ){
        args[["order_sample_by"]] <- deparse(slot(x, "order_sample_by_row"))
        args[["decreasing"]] <- deparse(slot(x, "decreasing"))
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotAbundance(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "AbundancePlot",
    function(x, se, output, pObjects, rObjects) {
    
    panel_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[panel_name]] <- renderPlot({
        .retrieveOutput(panel_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "AbundancePlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "AbundancePlot", function(x, field) {
    if( field %in% c("SelectionHistory", "RowSelectionRestrict",
        "RowSelectionDynamicSource", "RowSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "AbundancePlot",
    function(x, dim = character(0)) {
    
    if( "column" %in% dim ){
        return(TRUE)
    }
    return(FALSE)
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "AbundancePlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">Abundance Plot</font> panel
        contains a representation of the relative abundance
        for each taxonomic rank. Each column corresponds to
        a sample of the <code>SummarizedExperiment</code>
        object.", .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
#' @importFrom mia taxonomyRanks
#' @importFrom SummarizedExperiment rowData
.create_visual_box_for_abund_plot <- function(x, se) {
    
    panel_name <- .getEncodedName(x)
    
    .addSpecificTour(class(x)[1], "rank", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_rank + .selectize-control"), intro = "Here, we can select the
            taxonomic rank.")))})
    .addSpecificTour(class(x)[1], "add_legend", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add_legend"), intro = "Here, we can choose
            whether or not to show a legend.")))})
    .addSpecificTour(class(x)[1], "use_relative", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_use_relative"), intro = "Here, we can choose
            whether to use relative or absolute values.")))})
    .addSpecificTour(class(x)[1], "order_sample", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_order_sample"), intro = "Here, we can choose
            how to order the abundance plot by.")))})
    .addSpecificTour(class(x)[1], "decreasing", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_decreasing"), intro = "Here, we can choose
            whether or not to plot by decreasing order.")))})
    .addSpecificTour(class(x)[1], "order_sample_by_row", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_order_sample_by_row + .selectize-control"), intro = "Here, we can
            choose a variable from the <code>rowData</code> to order the plot by.
            It has to be part of the rank selected in the Visual Parameters.")))})
    .addSpecificTour(class(x)[1], "order_sample_by_column", function(panel_name) {
      data.frame(rbind(c(element = paste0("#", panel_name,
            "_order_sample_by_column + .selectize-control"), intro = "Here, we can
            choose a variable from the <code>colData</code> to order the plot by.")))})
    
    # Define what parameters the user can adjust
    collapseBox(paste0(panel_name, "_Visual"),
        title="Visual parameters", open=FALSE,
        # Rank
        .selectInput.iSEE(x, field="rank", label="Rank:",
            choices=taxonomyRanks(se), selected=slot(x, "rank")),
        # Colour legend
        .checkboxInput.iSEE(x, field="add_legend", label="View legend",
            value=slot(x, "add_legend")))
    
}

#' @importFrom SummarizedExperiment rowData
#' @importFrom mia taxonomyRanks
#' @importFrom utils stack
.list_taxa <- function(se){
  
    row_data <- as.data.frame(rowData(se)[ , taxonomyRanks(se)])
    names(row_data) <- taxonomyRanks(se)

    tax_opts <- unique(stack(row_data))
    tax_opts <- tax_opts[tax_opts$values != "" & !is.na(tax_opts$ind), ]
    tax_list <- lapply(split(tax_opts$values, tax_opts$ind), sort)

    return(tax_list)
}

test_that("AbundancePlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  panel <- AbundancePlot()
  
  panel[["rank"]] <- "Kingdom"
  
  expect_identical(.getEncodedName(panel), "AbundancePlotNA")
  expect_identical(.fullName(panel), "Abundance plot")
  expect_identical(.panelColor(panel), "#00E5EE")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 4)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
      'p <- miaViz::plotAbundance(se, rank="Kingdom", add_legend=TRUE,
    use_relative=TRUE)',
      fixed = TRUE)
  
  expect_true(.hideInterface(panel, "RowSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "row"))
  expect_true(.multiSelectionResponsive(panel, "column"))
  
  expect_contains(slotNames(panel), c("rank", "add_legend", "use_relative"))
  
  expect_contains(.definePanelTour(panel)[[1]],
                  c("#AbundancePlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_abund_plot(panel, tse),
                  "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$AbundancePlotNA, "shiny.render.function")
  expect_s3_class(output$AbundancePlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$AbundancePlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
  expect_identical(.exportOutput(panel, tse), "AbundancePlotNA.pdf")
  
})

#' Loading plot
#'
#' Contribution of single features in a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' to the components of a target reduced dimension. The panel implements
#' \code{\link[miaViz:plotLoadings]{plotLoadings}} to generate the plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{dimred}, a string specifying the dimred to visualize.
#' \item \code{layout}, a string specifying abundance layout (barplot or heatmap).
#' \item \code{ncomponents}, a number indicating the number of components to visualize.
#' \item \code{add.tree}, a logical indicating whether the tree should be shown.
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{LoadingPlot(...)} constructor creates an instance of an
#' LoadingPlot class, where any slot and its value can be passed to
#' \code{...} as a named argument.
#'
#' @examples
#' # Import libraries
#' library(mia)
#' library(scater)
#' 
#' # Import TreeSE
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' # Add relabundance assay
#' tse <- transformAssay(tse, method = "relabundance")
#' 
#' # Add reduced dimensions
#' tse <- runPCA(tse, assay.type = "relabundance")
#'
#' # Store panel into object
#' panel <- LoadingPlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name LoadingPlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("LoadingPlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("dimred", "layout"))
    msg <- .validNumberError(msg, x, "ncomponents", lower=1, upper=Inf)
    msg <- .validLogicalError(msg, x, fields="add.tree")

    if( length(msg) ){
        return(msg)
    }
    
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "LoadingPlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "dimred", "PCA")
    args <- .emptyDefault(args, "layout", "barplot")
    args <- .emptyDefault(args, "ncomponents", 5)
    args <- .emptyDefault(args, "add.tree", FALSE)
    
    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
LoadingPlot <- function(...) {
    new("LoadingPlot", ...)
}

#' @importFrom methods slot
#' @importFrom SingleCellExperiment reducedDim reducedDimNames
setMethod(".defineDataInterface", "LoadingPlot",
    function(x, se, select_info) {
    
    panel_name <- .getEncodedName(x)
    
    list(.selectInput.iSEE(x, field="dimred", label="Reduced dimension",
            choices=reducedDimNames(se), selected=slot(x, "dimred")),
        # Number of components
        .numericInput.iSEE(x, field="ncomponents", label="Number of components",
            value=slot(x, "ncomponents"), min=1, step=1,
            max=ncol(reducedDim(se, slot(x, "dimred")))))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "LoadingPlot",
    function(x, se, select_info) {
    
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_loading_plot(x, se), out[-1])
})

setMethod(".createObservers", "LoadingPlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name,
        c("dimred", "ncomponents"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name,
        c("layout", "add.tree"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "LoadingPlot", function(x) "Loading plot")
setMethod(".panelColor", "LoadingPlot", function(x) "#CCCC00")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "LoadingPlot", function(x) {
    plot_name <- .getEncodedName(x)
    
    addSpinner(
        plotOutput(plot_name, height = paste0(slot(x, "PanelHeight"), "px")),
        color=.panelColor(x))
})

#' @importFrom miaViz plotLoadings
setMethod(".generateOutput", "LoadingPlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )
    
    if( exists("row_selected", envir=panel_env, inherits=FALSE) ){
        panel_env[["se"]] <- se[unlist(panel_env[["row_selected"]]), ]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["dimred"]] <- deparse(slot(x, "dimred"))
    args[["layout"]] <- deparse(slot(x, "layout"))
    args[["add.tree"]] <- deparse(slot(x , "add.tree"))

    if( is.na(slot(x, "ncomponents")) || slot(x, "ncomponents") <= 0 ){
        args[["ncomponents"]] <- 5
    } else if( slot(x, "ncomponents") > ncol(reducedDim(se, slot(x, "dimred"))) ){
        args[["ncomponents"]] <- ncol(reducedDim(se, slot(x, "dimred")))
    } else {
        args[["ncomponents"]] <- deparse(slot(x, "ncomponents"))
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotLoadings(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "LoadingPlot",
            function(x, se, output, pObjects, rObjects) {
    
    plot_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[plot_name]] <- renderPlot({
        .retrieveOutput(plot_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "LoadingPlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "LoadingPlot", function(x, field) {
    
    if ( field %in% c("SelectionHistory", "ColumnSelectionRestrict",
                    "ColumnSelectionDynamicSource", "ColumnSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "LoadingPlot",
    function(x, dim = character(0)) {
    
    if ("row" %in% dim) {
        return(TRUE)
    }
    
    return(FALSE)
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "LoadingPlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">Loading Plot</font> panel
        contains a representation of the taxa contributions to the target
        reduced dimensions.", .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
#' @importFrom SummarizedExperiment colData
.create_visual_box_for_loading_plot <- function(x, se) {
    
    panel_name <- .getEncodedName(x)
    
    .addSpecificTour(class(x)[1], "layout", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_layout + .selectize-control"), intro = "Here, we can select the
            layout of the plot.")))})
    .addSpecificTour(class(x)[1], "add.tree", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.tree"), intro = "Here, we can choose
            whether or not to show the phylogenetic tree.")))})
    
    # Define what parameters the user can adjust
    collapseBox(
        paste0(panel_name, "_Visual"), title="Visual parameters", open=FALSE,
            # Panel layout
            .selectInput.iSEE(x, field="layout", label="Layout",
                choices=c("barplot", "heatmap", "lollipop"),
                selected=slot(x, "layout")),
            # Add tree
            .checkboxInput.iSEE(x, field="add.tree", label="View tree",
                value=slot(x, "add.tree")))
}

test_that("LoadingPlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  panel <- LoadingPlot()
  
  panel[["layout"]] <- "heatmap"

  tse <- scater::runPCA(tse, assay.type = "counts", ncomponents = 5)
  
  expect_identical(.getEncodedName(panel), "LoadingPlotNA")
  expect_identical(.fullName(panel), "Loading plot")
  expect_identical(.panelColor(panel), "#CCCC00")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 2)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
  "p <- miaViz::plotLoadings(se, dimred=\"PCA\", layout=\"heatmap\", add.tree=FALSE,\n    ncomponents=5)",
  fixed = TRUE)
  
  expect_true(.hideInterface(panel, "ColumnSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "column"))
  expect_true(.multiSelectionResponsive(panel, "row"))
  
  expect_contains(slotNames(panel), c("dimred", "layout", "ncomponents", "add.tree"))
  
  expect_contains(.definePanelTour(panel)[[1]],
      c("#LoadingPlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_loading_plot(panel, tse), "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$LoadingPlotNA, "shiny.render.function")
  expect_s3_class(output$LoadingPlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$LoadingPlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
  expect_identical(.exportOutput(panel, tse), "LoadingPlotNA.pdf")
  
})

#' Graph plot
#'
#' The Graph plot is a virtual class that showcases the network organisation of
#' either the features or samples of a
#' \code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
#' object. The \linkS4class{RowGraphPlot} and \linkS4class{ColumnGraphPlot}
#' classes belong to this family and are specialised to visualise the feature
#' or sample igraphs stored in metadata, respectively.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{name}: \code{Character scalar}. Metadata name containing graph.
#'   (Default: \code{"graph"})
#' \item \code{assay.type}: \code{Character scalar}. Assay type to use.
#'   (Default: \code{"counts"})
#' \item \code{layout}: \code{Character scalar}. Graph layout.
#'   (Default: \code{"kk"})
#'  \item \code{edge.type}: \code{Character scalar}. Edge type.
#'   (Default: \code{"fan"})
#' \item \code{show.label}: \code{Logical scalar}. Should node labels be shown.
#'   (Default: \code{FALSE})
#' \item \code{add.legend}: \code{Logical scalar}. Should legend be shown.
#'   (Default: \code{TRUE})
#' \item \code{edge.colour.by}: \code{Character scalar}. Parameter to colour
#'   lines by when \code{colour_parameters = "Edge"}. (Default: \code{NULL})
#' \item \code{edge.size.by}: \code{Character scalar}. Parameter to size lines
#'   by when \code{size_parameters = "Edge"}. (Default: \code{NULL})
#' \item \code{node.colour.by}: \code{Character scalar}. Parameter to colour
#'   nodes by when \code{colour_parameters = "Node"}. (Default: \code{NULL})
#' \item \code{node.size.by}: \code{Character scalar}. Parameter to size nodes
#'   by when \code{size_parameters = "Node"}. (Default: \code{NULL})
#' \item \code{node.shape.by}: \code{Character scalar}. Parameter to shape nodes
#'   by when \code{shape_parameters = "Node"}. (Default: \code{NULL})
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#' 
#' @seealso
#' \linkS4class{RowGraphPlot}
#' \linkS4class{ColumnGraphPlot}
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name GraphPlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("GraphPlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("name", "assay.type", "layout",
        "edge.type", "edge.colour.by", "edge.size.by", "node.colour.by",
        "node.shape.by", "node.size.by"))
    msg <- .validLogicalError(msg, x, fields=c("add.legend", "show.label"))

    if (length(msg)) {
        return(msg)
    }
    
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "GraphPlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "name", "graph")
    args <- .emptyDefault(args, "assay.type", "counts")
    args <- .emptyDefault(args, "layout", "kk")
    args <- .emptyDefault(args, "edge.type", "fan")
    args <- .emptyDefault(args, "show.label", FALSE)
    args <- .emptyDefault(args, "add.legend", TRUE)
    args <- .emptyDefault(args, "edge.colour.by", NA_character_)
    args <- .emptyDefault(args, "edge.size.by", NA_character_)
    args <- .emptyDefault(args, "node.colour.by", NA_character_)
    args <- .emptyDefault(args, "node.size.by", NA_character_)
    args <- .emptyDefault(args, "node.shape.by", NA_character_)
    args <- .emptyDefault(args, "visual_parameters", NA_character_)
    args <- .emptyDefault(args, "colour_parameters", NA_character_)
    args <- .emptyDefault(args, "shape_parameters", NA_character_)
    args <- .emptyDefault(args, "size_parameters", NA_character_)

    do.call(callNextMethod, c(list(.Object), args))
})

#' @importFrom methods slot
#' @importFrom S4Vectors metadata
#' @importFrom SummarizedExperiment assayNames
setMethod(".defineDataInterface", "GraphPlot", function(x, se, select_info) {
  panel_name <- .getEncodedName(x)
  list(.selectInput.iSEE(x, field="name", label="Graph name:",
            choices=names(metadata(se)), selected=slot(x, "name")),
       .selectInput.iSEE(x, field="assay.type", label="Assay type:",
            choices=assayNames(se), selected=slot(x, "assay.type")),
       .checkboxInput.iSEE(x, field="show.label", label="Show node labels",
          value=slot(x, "show.label")))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "GraphPlot", function(x, se, select_info) {
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_graph(x, se), out[-1])
})

setMethod(".createObservers", "GraphPlot",
    function(x, se, input, session, pObjects, rObjects) {
    callNextMethod()
    panel_name <- .getEncodedName(x)

    .createProtectedParameterObservers(panel_name, c("layout", "assay.type",
        "name", "edge.type", "show.label", "add.legend", "RowSelectionSource",
        "visual_parameters", "colour_parameters", "size_parameters",
        "shape_parameters"), input=input, pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("edge.colour.by",
        "edge.size.by", "node.size.by", "node.colour.by", "node.shape.by",
        "node.size.by"), input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "GraphPlot", function(x) {
    panel_name <- .getEncodedName(x)

    addSpinner(plotOutput(panel_name,
        height = paste0(slot(x, "PanelHeight"), "px")), color=.panelColor(x))
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "GraphPlot",
    function(x, se, output, pObjects, rObjects) {

    panel_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[panel_name]] <- renderPlot({
        .retrieveOutput(panel_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "GraphPlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "GraphPlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">%s</font> panel contains a network or graph
        from the 
        <i><a href='https://microbiome.github.io/miaViz/reference/plotGraph.html'>miaViz</a></i>
        package.", .getPanelColor(x), .fullName(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the graph.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "VisualBoxOpen", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        tree.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
#' @importFrom S4Vectors metadata
#' @importFrom tidygraph activate
#' @importFrom SummarizedExperiment rowData colData
.create_visual_box_for_graph <- function(x, se) {
    panel_name <- .getEncodedName(x)
    
    edge_data <- as.data.frame(activate(metadata(se)[[slot(x, "name")]], "edges"))
    gr_data <- switch(substr(panel_name, 1, 3),
        Row = rowData(se), Col = colData(se))

    .addSpecificTour(class(x)[1], "layout", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_layout + .selectize-control"), intro = "Here, we can select the
            layout of the network")))})
    .addSpecificTour(class(x)[1], "edge.type", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_edge\\.type + .selectize-control"), intro = "Here, we can select
            the edge type of the network")))})
    .addSpecificTour(class(x)[1], "add.legend", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.legend"), intro = "Here, we can choose
            whether or not to show a legend.")))})
    .addSpecificTour(class(x)[1], "edge.colour.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_edge\\.colour\\.by + .selectize-control"), intro = "Here, we can
            choose whether or not to colour the lines by a variable from the
            <code>metadata</code>. When active, the available options are listed
            and one of them can be selected.")))})
    .addSpecificTour(class(x)[1], "edge.size.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_edge\\.size\\.by + .selectize-control"), intro = "Here, we can
            choose whether or not to colour the tips by a variable from the
            <code>metadata</code>. When active, the available options are listed
            and one of them can be selected.")))})
    .addSpecificTour(class(x)[1], "node.colour.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_node\\.colour\\.by + .selectize-control"), intro = "Here, we can
            choose whether or not to colour the nodes by a variable from the
            <code>metadata</code>. When active, the available options are listed
            and one of them can be selected.")))})
    .addSpecificTour(class(x)[1], "node.shape.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_node\\.shape\\.by + .selectize-control"), intro = "Here, we can
            order the tree alphabetically.")))})
    .addSpecificTour(class(x)[1], "node.size.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_node\\.size\\.by + .selectize-control"), intro = "Here, we can
            choose how to colour the  tips by.")))})
    .addSpecificTour(class(x)[1], "visual_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_visual_parameters"), intro = "Here, we can 
            choose to show the different visual parameters.")))})
    .addSpecificTour(class(x)[1], "colour_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_colour_parameters"), intro = "Here, we can make 
            the colour depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    .addSpecificTour(class(x)[1], "shape_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_shape_parameters"), intro = "Here, we can make 
            the shape depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    .addSpecificTour(class(x)[1], "size_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_size_parameters"), intro = "Here, we can make 
            the size depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    
    # Define what parameters the user can adjust
    collapseBox(paste0(panel_name, "_VisualBoxOpen"),
        title="Visual parameters", open=FALSE,
        # Graph layout
        .selectInput.iSEE(x, field="layout", label="Layout:",
            choices=c("kk", "linear", "matrix", "backbone", "fabric", "stress",
            "unrooted"), selected=slot(x, "layout")),
        .selectInput.iSEE(x, field="edge.type", label="Edge type:",
            choices=c("fan", "link", "arc", "parallel"),
            selected=slot(x, "edge.type")),
        .checkboxInput.iSEE(x, field="add.legend", label="View legend",
            value=slot(x, "add.legend")),
        .checkboxGroupInput.iSEE(x, field="visual_parameters", label=NULL,
            inline=TRUE, selected=slot(x, "visual_parameters"),
            choices=c("Colour", "Size", "Shape")),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Colour",
            list(
                .checkboxGroupInput.iSEE(x, field="colour_parameters",
                    inline=TRUE, selected=slot(x, "colour_parameters"),
                    choices=c("Edge", "Node"), label="Colour by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_colour_parameters"), "Edge",
                        .selectInput.iSEE(x, field="edge.colour.by",
                            label="Colour lines by", choices=names(edge_data),
                            selected=slot(x, "edge.colour.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_colour_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.colour.by",
                            label="Colour nodes by", choices=names(gr_data),
                            selected=slot(x, "node.colour.by"))))),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Size",
            list(
                .checkboxGroupInput.iSEE(x, field="size_parameters",
                    inline=TRUE, selected=slot(x, "size_parameters"),
                    choices=c("Edge", "Node"), label="Size by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_size_parameters"), "Edge",
                        .selectInput.iSEE(x, field="edge.size.by",
                            label="Size lines by", choices=names(edge_data),
                            selected=slot(x, "edge.size.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_size_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.size.by",
                            label="Size nodes by", choices=names(gr_data),
                            selected=slot(x, "node.size.by"))))),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Shape",
            list(
                .checkboxGroupInput.iSEE(x, field="shape_parameters",
                    inline=TRUE, selected=slot(x, "shape_parameters"),
                    choices=c("Node"), label="Shape by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_shape_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.shape.by",
                            label="Shape nodes by", choices=names(gr_data),
                            selected=slot(x, "node.shape.by"))))))

}

test_that("RowGraphPlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("GlobalPatterns", package = "mia")
  tse <- GlobalPatterns
  
  data("row_graph_order", package = "miaViz")
  
  tse  <- mia::agglomerateByRank(tse, rank = "Order", na.rm = TRUE)
  metadata(tse)$graph <- row_graph_order
  
  panel <- RowGraphPlot()
  
  panel[["layout"]] <- "kk"
  
  expect_identical(.getEncodedName(panel), "RowGraphPlotNA")
  expect_identical(.fullName(panel), "Row graph plot")
  expect_identical(.panelColor(panel), "orange")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 3)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
      'p <- miaViz::plotRowGraph(se, name=\"graph\", assay.type=\"counts\",\n    show.label=FALSE, layout=\"kk\", edge.type=\"fan\", add.legend=TRUE)',
      fixed = TRUE)
  
  expect_true(.hideInterface(panel, "ColumnSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "column"))
  expect_true(.multiSelectionResponsive(panel, "row"))
  
  expect_contains(slotNames(panel), c("name", "assay.type", "layout",
      "show.label", "add.legend", "edge.colour.by", "edge.size.by",
      "node.colour.by", "node.shape.by", "node.size.by"))
  
  expect_contains(.definePanelTour(panel)[[1]],
      c("#RowGraphPlotNA_DataBoxOpen", "#RowGraphPlotNA_VisualBoxOpen",
      "#RowGraphPlotNA", "#RowGraphPlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_graph(panel, tse), "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$RowGraphPlotNA, "shiny.render.function")
  expect_s3_class(output$RowGraphPlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$RowGraphPlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
  expect_identical(.exportOutput(panel, tse), "RowGraphPlotNA.pdf")
  
})

#' iSEEtree utils
#' 
#' Utility functions to check the existence of specific elements in a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' that are compulsory when using certain panels.
#' 
#' @param se a
#' \code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
#' object.
#' 
#' @param initial \code{Panel vector}. A list of panel objects to check.
#' 
#' @param panel.class \code{Character vector}. A list of panel names
#'   corresponding to panel objects in \code{initial}.
#' 
#' @param panel.fun \code{Function scalar}. The element of \code{se} whose
#'   existence should be checked.
#' 
#' @param wtext \code{Character scalar}. Text of the warning message returned
#'   if \code{panel.fun} does not exist or is empty.
#' 
#' @return
#' \code{.check_panel} returns the input \code{initial} list of panels excluding
#' the checked panel if \code{panel.fun} is \code{NULL} or empty.
#' \code{.check_all_panels} applies \code{.check_panel} to multiple panels and
#' returns the a filtered version of \code{initial}.
#'
#' @examples
#' # Import libraries
#' library(mia)
#' library(TreeSummarizedExperiment)
#' 
#' # Import TreeSE
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#'
#' # Create list of panels
#' initial <- c(RowTreePlot(), ColumnTreePlot())
#' # If RowTreePlot is in initial, check whether rowLinks is defined
#' initial <- .check_panel(tse, initial, "RowTreePlot", rowLinks)
#' # If ColumnTreePlot is in initial, check whether colLinks is defined
#' initial <- .check_panel(tse, initial, "ColumnTreePlot", colLinks)
#' 
#' # View filtered list of panels
#' initial
#' 
#' @keywords internal
#' @name utils
NULL

#' @rdname utils
#' @export
#' @importFrom TreeSummarizedExperiment TreeSummarizedExperiment rowLinks
#'   colLinks
#' @importFrom SingleCellExperiment reducedDims
#' @importFrom S4Vectors metadata
#' @importFrom SummarizedExperiment rowData colData
#' @importFrom mia taxonomyRanks
.check_all_panels <- function(se, initial){
    initial <- .check_panel(se, initial, "RowDataTable", rowData)
    initial <- .check_panel(se, initial, "ColumnDataTable", colData)
    initial <- .check_panel(se, initial, "RowTreePlot", rowLinks)
    initial <- .check_panel(se, initial, "ColumnTreePlot", colLinks)
    initial <- .check_panel(se, initial, "AbundancePlot", taxonomyRanks)
    initial <- .check_panel(se, initial, "ReducedDimensionPlot", reducedDims)
    initial <- .check_panel(se, initial, "LoadingPlot", reducedDims)
    initial <- .check_panel(se, initial, "ScreePlot", reducedDims)
    initial <- .check_panel(se, initial, "RDAPlot", reducedDims)
    initial <- .check_panel(se, initial, "RowGraphPlot", metadata)
    initial <- .check_panel(se, initial, "ColumnGraphPlot", metadata)
    return(initial)
}

#' @rdname utils
#' @export
#' @importFrom S4Vectors isEmpty
#' @importFrom methods is
.check_panel <- function(se, initial, panel.class, panel.fun, wtext) {
    
    no_keep <- unlist(lapply(initial, function(x) is(x, panel.class)))

    if( any(no_keep) && (is.null(panel.fun(se)) || isEmpty(panel.fun(se))) ){
        initial <- initial[!no_keep]
        warning("no valid ", as.character(substitute(panel.fun)),
            " fields for ", panel.class, call. = FALSE)
    }
    
    return(initial)
}

#' iSEE extension for the TreeSummarizedExperiment container
#'
#' \code{iSEEtree} is an extension of \pkg{iSEE} that provides panels for the
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' container, enabling the interactive visualisation of typical microbiome data.
#' The panel layout of iSEEtree is described in \code{\link{iSEE}}.
#'
#' @examples
#' library(iSEEtree)
#' 
#' @seealso \link[iSEE:iSEE]{iSEE} \link[mia:mia]{mia}
#' 
#' @author Giulio Benedetti \email{giulio.benedetti@@utu.fi}
#' 
#' @docType package
#' @keywords internal
#' @name iSEEtree-package
#' 
"_PACKAGE"

#' Column graph plot
#'
#' Network organisation for the samples of a
#' \code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
#' object. The igraph should be stored in the \code{metadata} slot by a name
#' containing \code{"graph"}. This panel uses
#' \code{\link[miaViz:plotColGraph]{plotColGraph}}
#' to generate the plot.
#'
#' @section Slot overview:
#'
#' This class inherits all slots from its parent class \linkS4class{GraphPlot}.
#'
#' @return
#' The \code{ColumnGraphPlot(...)} constructor creates an instance of a
#' ColumnGraphPlot class, where any slot and its value can be passed to
#' \code{...} as a named argument.
#'
#' @examples
#' library(mia)
#' library(miaViz)
#' data("GlobalPatterns", library = "mia")
#' data("col_graph", library = "miaViz")
#' 
#' tse <- GlobalPatterns
#' tse <- agglomerateByRank(tse,
#'                          rank = "Genus",
#'                          na.rm = TRUE)
#'                          
#' metadata(tse)$graph <- col_graph
#' 
#' # Store panel into object
#' panel <- ColumnGraphPlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @seealso
#' \linkS4class{GraphPlot}
#' \linkS4class{RowGraphPlot}
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name ColumnGraphPlot
NULL

#' @export
#' @importFrom methods new
ColumnGraphPlot <- function(...) {
    new("ColumnGraphPlot", ...)
}

setMethod(".fullName", "ColumnGraphPlot", function(x) "Column graph plot")
setMethod(".panelColor", "ColumnGraphPlot", function(x) "purple")

#' @importFrom miaViz plotColGraph
setMethod(".generateOutput", "ColumnGraphPlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)

    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )

    if( exists("col_selected", envir=panel_env, inherits=FALSE) ) {
        panel_env[["se"]] <- se[unlist(panel_env[["col_selected"]]), ]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["name"]] <- deparse(slot(x, "name"))
    args[["assay.type"]] <- deparse(slot(x, "assay.type"))
    args[["show.label"]] <- deparse(slot(x, "show.label"))
    args[["layout"]] <- deparse(slot(x, "layout"))
    args[["edge.type"]] <- deparse(slot(x, "edge.type"))
    args[["add.legend"]] <- deparse(slot(x, "add.legend"))
    
    if( "Colour" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Edge", "colour")
        args <- .assign_viz_param(args, x, "Node", "colour",
            arg.name = "colour.by")
    }
    
    if( "Shape" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Node", "shape",
            arg.name = "shape.by")
    }
    
    if( "Size" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Edge", "size",
            arg.name = "edge.width.by")
        args <- .assign_viz_param(args, x, "Node", "size", arg.name = "size.by")
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse = ", ")
    fun_call <- sprintf("p <- miaViz::plotColGraph(se, %s)", args)

    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd

    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "ColumnGraphPlot", function(x, field) {
    
    if( field %in% c("SelectionHistory", "ColumnSelectionRestrict",
        "ColumnSelectionDynamicSource", "ColumnSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "ColumnGraphPlot",
    function(x, dim = character(0)) {
    
    if( "column" %in% dim ){
        return(TRUE)
    }

    return(FALSE)
})

tree_slots <- c(layout="character", add.legend="logical",
    edge.colour.by="character", tip.colour.by="character", order.tree="logical",
    tip.size.by="character", edge.size.by="character", tip.shape.by="character",
    node.size.by="character", node.shape.by="character", collapse="character",
    node.colour.by="character", add.node.lab="logical", add.tip.lab="logical",
    open.angle="numeric", rotate.angle="numeric", branch.length="logical",
    visual_parameters="character", size_parameters="character",
    shape_parameters="character", colour_parameters="character")

#' @rdname TreePlot
#' @export
setClass("TreePlot", contains=c("Panel", "VIRTUAL"), slots=tree_slots)

#' @rdname RowTreePlot
#' @export
setClass("RowTreePlot", contains="TreePlot")

#' @rdname ColumnTreePlot
#' @export
setClass("ColumnTreePlot", contains="TreePlot")

graph_slots <- c(name="character", assay.type="character", layout="character",
    edge.type="character", show.label="logical", add.legend="logical",
    edge.colour.by="character", edge.size.by="character",
    node.colour.by="character", node.shape.by="character",
    node.size.by="character", visual_parameters="character",
    size_parameters="character", shape_parameters="character",
    colour_parameters="character")

#' @rdname GraphPlot
#' @export
setClass("GraphPlot", contains=c("Panel", "VIRTUAL"), slots=graph_slots)

#' @rdname RowGraphPlot
#' @export
setClass("RowGraphPlot", contains="GraphPlot")

#' @rdname ColumnGraphPlot
#' @export
setClass("ColumnGraphPlot", contains="GraphPlot")

setClassUnion("charlog", c("character", "logical"))

#' @rdname RDAPlot
#' @export
setClass("RDAPlot", contains="Panel", slots=c(dimred="character",
    add.ellipse="charlog", colour_by="character", vec.text="logical",
    add.vectors="logical", ellipse.alpha="numeric", confidence.level="numeric",
    add.significance="logical", add.expl.var="logical", ellipse.linewidth="numeric",
    ellipse.linetype="numeric", vec.size="numeric", vec.colour="character",
    vec.linetype="numeric", arrow.size="numeric", label.colour="character",
    label.size="numeric", visual_parameters="character"))

#' @rdname LoadingPlot
#' @export
setClass("LoadingPlot", contains="Panel", slots=c(dimred="character",
    layout="character", ncomponents="numeric", add.tree="logical"))

#' @rdname ScreePlot
#' @export
setClass("ScreePlot", contains="Panel", slots=c(dimred="character",
    show.barplot="logical", show.points="logical", show.line="logical",
    show.labels="logical", add.proportion="logical", add.cumulative="logical",
    n="numeric", show.names="logical", eig.name="character"))

#' @rdname AbundancePlot
#' @export
setClass("AbundancePlot", contains="Panel",
    slots=c(rank="character", use_relative="logical", add_legend="logical",
    order_sample_by_row="character", order_sample="character", 
    decreasing="logical", order_sample_by_column="character"))

#' @rdname AbundanceDensityPlot
#' @export
setClass("AbundanceDensityPlot", contains="Panel", slots=c(layout="character",
    assay.type="character", n="numeric", dots_colour="character",
    dots_colour_by="character", add_legend="logical", flipped="logical",
    order_descending="logical", dots_shape="character",
    dots_shape_by="character"))

#' @rdname PrevalencePlot
#' @export
setClass("PrevalencePlot", contains="Panel", slots=c(detection="numeric",
    prevalence="numeric", assay.type="character", rank="character",
    include.lowest="logical", show.rank="logical"))

#' Tree plot
#'
#' The TreePlot is a virtual class that creates a hierarchical tree of either
#' the features or samples of a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' object. The \linkS4class{RowTreePlot} and \linkS4class{ColumnTreePlot}
#' classes belong to this family and are specialised to visualise the rowTree
#' and the colTree, respectively.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{layout}: \code{Character scalar}. Tree layout.
#'   (Default: \code{"fan"})
#' \item \code{add.legend}: \code{Logical scalar}. Should legend be shown.
#'   (Default: \code{TRUE})
#' \item \code{edge.colour.by}: \code{Character scalar}. Parameter to colour
#'   lines by when \code{colour_parameters = "Edge"}. (Default: \code{NULL})
#' \item \code{edge.size.by}: \code{Character scalar}. Parameter to size lines
#'   by when \code{size_parameters = "Edge"}. (Default: \code{NULL})
#' \item \code{tip.colour.by}: \code{Character scalar}. Parameter to colour tips
#'   by when \code{colour_parameters = "Tip"}. (Default: \code{NULL})
#' \item \code{tip.size.by}: \code{Character scalar}. Parameter to size tips by
#'   when \code{size_parameters = "Tip"}. (Default: \code{NULL})
#' \item \code{tip.shape.by}: \code{Character scalar}. Parameter to shape tips
#'   by when \code{shape_parameters = "Tip"}. (Default: \code{NULL})
#' \item \code{node.colour.by}: \code{Character scalar}. Parameter to colour
#'   nodes by when \code{colour_parameters = "Node"}. (Default: \code{NULL})
#' \item \code{node.size.by}: \code{Character scalar}. Parameter to size nodes
#'   by when \code{size_parameters = "Node"}. (Default: \code{NULL})
#' \item \code{node.shape.by}: \code{Character scalar}. Parameter to shape nodes
#'   by when \code{shape_parameters = "Node"}. (Default: \code{NULL})
#' \item \code{order.tree}: \code{Logical scalar}. Should the tree be ordered
#'   alphabetically by the taxonomic levels. (Default: \code{FALSE})
#' \item \code{open.angle}: \code{Numeric scalar}. Angle by which the tree is
#'   opened when \code{layout} is \code{"fan"}. (Default: \code{0})
#' \item \code{rotate.angle}: \code{Numeric scalar}. Angle by which the tree is
#'   rotated. (Default: \code{0})
#' \item \code{branch.length}: \code{Logical scalar}. Should branch length be
#'   equalised. (Default: \code{FALSE})
#' }
#'
#' In addition, this class inherits all slots from its parent
#' \code{\link[iSEE:Panel-class]{Panel}}.
#' 
#' @seealso
#' \linkS4class{RowTreePlot}
#' \linkS4class{ColumnTreePlot}
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name TreePlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("TreePlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("layout", "edge.colour.by",
        "tip.colour.by", "tip.size.by", "edge.size.by", "tip.shape.by",
        "node.colour.by", "node.size.by", "node.shape.by"))
    msg <- .validLogicalError(msg, x, fields=c("add.legend", "order.tree",
        "branch.length", "add.node.lab", "add.tip.lab"))
    msg <- .validNumberError(msg, x, "open.angle", lower=0, upper=360)
    msg <- .validNumberError(msg, x, "rotate.angle", lower=0, upper=360)

    if (length(msg)) {
        return(msg)
    }
    
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "TreePlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "layout", "fan")
    args <- .emptyDefault(args, "add.legend", TRUE)
    args <- .emptyDefault(args, "edge.colour.by", NA_character_)
    args <- .emptyDefault(args, "edge.size.by", NA_character_)
    args <- .emptyDefault(args, "tip.colour.by", NA_character_)
    args <- .emptyDefault(args, "tip.size.by", NA_character_)
    args <- .emptyDefault(args, "tip.shape.by", NA_character_)
    args <- .emptyDefault(args, "node.colour.by", NA_character_)
    args <- .emptyDefault(args, "node.size.by", NA_character_)
    args <- .emptyDefault(args, "node.shape.by", NA_character_)
    args <- .emptyDefault(args, "visual_parameters", NA_character_)
    args <- .emptyDefault(args, "colour_parameters", NA_character_)
    args <- .emptyDefault(args, "shape_parameters", NA_character_)
    args <- .emptyDefault(args, "size_parameters", NA_character_)
    args <- .emptyDefault(args, "order.tree", FALSE)
    args <- .emptyDefault(args, "collapse", NA_character_)
    args <- .emptyDefault(args, "add.node.lab", FALSE)
    args <- .emptyDefault(args, "add.tip.lab", FALSE)
    args <- .emptyDefault(args, "open.angle", 0)
    args <- .emptyDefault(args, "rotate.angle", 0)
    args <- .emptyDefault(args, "branch.length", FALSE)

    do.call(callNextMethod, c(list(.Object), args))
})

#' @importFrom methods slot
setMethod(".defineDataInterface", "TreePlot", function(x, se, select_info) {
  panel_name <- .getEncodedName(x)
  list(.checkboxInput.iSEE(x, field="add.node.lab", label="Show node labels",
          value=slot(x, "add.node.lab")),
       .checkboxInput.iSEE(x, field="add.tip.lab", label="Show tip labels",
          value=slot(x, "add.tip.lab")),
       .sliderInput.iSEE(x, field="open.angle", label="Open by angle:",
          min=0, max=360, step=1, value=slot(x, "open.angle")),
       .sliderInput.iSEE(x, field="rotate.angle", label="Rotate by angle:",
          min=0, max=360, step=1, value=slot(x, "rotate.angle")),
       .checkboxInput.iSEE(x, field="order.tree", label="Order tree",
          value=slot(x, "order.tree")),
       .checkboxInput.iSEE(x, field="branch.length", label="Equalise length",
          value=slot(x, "branch.length")))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "TreePlot", function(x, se, select_info) {
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_tree(x, se), out[-1])
})

setMethod(".createObservers", "TreePlot",
    function(x, se, input, session, pObjects, rObjects) {
    callNextMethod()
    panel_name <- .getEncodedName(x)

    .createProtectedParameterObservers(panel_name, c("layout", "add.legend",
        "RowSelectionSource", "order.tree", "size_parameters", "visual_parameters",
        "shape_parameters", "colour_parameters", "open.angle", "rotate.angle",
        "branch.length", "collapse"), input=input, pObjects=pObjects,
        rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("edge.colour.by",
        "tip.colour.by", "tip.size.by", "tip.shape.by", "node.size.by",
        "node.shape.by", "node.colour.by", "edge.size.by", "add.node.lab",
        "add.tip.lab"), input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "TreePlot", function(x) {
    panel_name <- .getEncodedName(x)

    addSpinner(plotOutput(panel_name,
        height = paste0(slot(x, "PanelHeight"), "px")), color=.panelColor(x))
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "TreePlot",
    function(x, se, output, pObjects, rObjects) {

    panel_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[panel_name]] <- renderPlot({
        .retrieveOutput(panel_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "TreePlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "TreePlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">%s</font> panel contains a phylogenetic
        tree from the 
        <i><a href='https://microbiome.github.io/miaViz/reference/plotTree.html'>miaViz</a></i>
        package.", .getPanelColor(x), .fullName(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the tree.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "VisualBoxOpen", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        tree.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom SummarizedExperiment rowData colData
.create_visual_box_for_tree <- function(x, se) {
    panel_name <- .getEncodedName(x)
    tr_data <- switch(substr(panel_name, 1, 3),
        Row = rowData(se), Col = colData(se))
    
    .addSpecificTour(class(x)[1], "layout", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_layout + .selectize-control"), intro = "Here, we can select the
            layout of the tree.")))})
    .addSpecificTour(class(x)[1], "add.legend", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.legend"), intro = "Here, we can choose
            whether or not to show a legend.")))})
    .addSpecificTour(class(x)[1], "add.tip.lab", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.tip\\.lab"), intro = "Here, we can choose
            whether or not to show the tip labels.")))})
    .addSpecificTour(class(x)[1], "add.node.lab", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.node\\.lab"), intro = "Here, we can choose
            whether or not to show the node numbers.")))})
    .addSpecificTour(class(x)[1], "rotate.angle", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_rotate\\.angle"), intro = "Here, we can specify the angle by which
            to rotate the tree.")))})
    .addSpecificTour(class(x)[1], "open.angle", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_open\\.angle"), intro = "Here, we can specify the angle by which
            to open the tree.")))})
    .addSpecificTour(class(x)[1], "branch.length", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_branch\\.length"), intro = "Here, we can choose whether branch
            length should be equalised.")))})
    .addSpecificTour(class(x)[1], "order.tree", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_order\\.tree"), intro = "Here, we can order
            the tree alphabetically.")))})
    .addSpecificTour(class(x)[1], "tip.colour.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_tip\\.colour\\.by + .selectize-control"), intro = "Here, we can
            choose how to colour the  tips by.")))})
    .addSpecificTour(class(x)[1], "tip.size.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_tip\\.size\\.by + .selectize-control"), intro = "Here, we can 
            choose how to size the tree tips by.")))})
    .addSpecificTour(class(x)[1], "tip.shape.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_tip\\.shape\\.by + .selectize-control"), intro = "Here, we can 
            choose how to shape the tree tips by.")))})
    .addSpecificTour(class(x)[1], "edge.colour.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_edge\\.colour\\.by + .selectize-control"), intro = "Here, we can 
            choose how to colour the tree edges by.")))})
    .addSpecificTour(class(x)[1], "edge.size.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_edge\\.size\\.by + .selectize-control"), intro = "Here, we can 
            choose how to size the tree edges by.")))})
    .addSpecificTour(class(x)[1], "node.size.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_node\\.size\\.by + .selectize-control"), intro = "Here, we can 
            choose how to size the tree nodes by.")))})
    .addSpecificTour(class(x)[1], "node.shape.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_node\\.shape\\.by + .selectize-control"), intro = "Here, we can 
            choose how to shape the tree nodes by.")))})
    .addSpecificTour(class(x)[1], "node.colour.by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
             "_node\\.colour\\.by + .selectize-control"), intro = "Here, we can 
            choose how to colour the tree nodes by.")))})
    .addSpecificTour(class(x)[1], "visual_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_visual_parameters"), intro = "Here, we can 
            choose to show the different visual parameters.")))})
    .addSpecificTour(class(x)[1], "colour_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_colour_parameters"), intro = "Here, we can make 
            the colour depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    .addSpecificTour(class(x)[1], "shape_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_shape_parameters"), intro = "Here, we can make 
            the shape depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    .addSpecificTour(class(x)[1], "size_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_size_parameters"), intro = "Here, we can make 
            the size depend on the value of a
            categorical column data field for each plot components
            (line, tip, node).")))})
    
    # Define what parameters the user can adjust
    collapseBox(paste0(panel_name, "_VisualBoxOpen"),
        title="Visual parameters", open=FALSE,
        # Tree layout
        .selectInput.iSEE(x, field="layout", label="Layout:",
            choices=c("fan", "rectangular", "circular", "slanted",
                "inward_circular", "radial", "unrooted", "equal_angle",
                "daylight", "dendrogram", "ape", "ellipse", "roundrect"),
                selected=slot(x, "layout")),
        .checkboxInput.iSEE(x, field="add.legend", label="View legend",
            value=slot(x, "add.legend")),
        .checkboxGroupInput.iSEE(x, field="visual_parameters", label=NULL,
            inline=TRUE, selected=slot(x, "visual_parameters"),
            choices=c("Colour", "Size", "Shape")),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Colour",
            list(
                .checkboxGroupInput.iSEE(x, field="colour_parameters",
                    inline=TRUE, selected=slot(x, "colour_parameters"),
                    choices=c("Edge", "Node", "Tip"), label="Colour by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_colour_parameters"), "Edge",
                        .selectInput.iSEE(x, field="edge.colour.by",
                            label="Colour lines by", choices=names(tr_data),
                            selected=slot(x, "edge.colour.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_colour_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.colour.by",
                            label="Colour nodes by", choices=names(tr_data),
                            selected=slot(x, "node.colour.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_colour_parameters"), "Tip",
                        .selectInput.iSEE(x, field="tip.colour.by",
                            label="Colour tips by", choices=names(tr_data),
                            selected=slot(x, "tip.colour.by"))))),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Size",
            list(
                .checkboxGroupInput.iSEE(x, field="size_parameters",
                    inline=TRUE, selected=slot(x, "size_parameters"),
                    choices=c("Edge", "Node", "Tip"), label="Size by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_size_parameters"), "Edge",
                        .selectInput.iSEE(x, field="edge.size.by",
                            label="Size lines by", choices=names(tr_data),
                            selected=slot(x, "edge.size.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_size_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.size.by",
                            label="Size nodes by", choices=names(tr_data),
                            selected=slot(x, "node.size.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_size_parameters"), "Tip",
                        .selectInput.iSEE(x, field="tip.size.by",
                            label="Size tips by", choices=names(tr_data),
                            selected=slot(x, "tip.size.by"))))),
        
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Shape",
            list(
                .checkboxGroupInput.iSEE(x, field="shape_parameters",
                    inline=TRUE, selected=slot(x, "shape_parameters"),
                    choices=c("Node", "Tip"), label="Shape by:"),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_shape_parameters"), "Node",
                        .selectInput.iSEE(x, field="node.shape.by",
                            label="Shape nodes by", choices=names(tr_data),
                            selected=slot(x, "node.shape.by"))),
                .conditionalOnCheckGroup(
                    paste0(panel_name, "_shape_parameters"), "Tip",
                        .selectInput.iSEE(x, field="tip.shape.by",
                            label="Shape tips by", choices=names(tr_data),
                            selected=slot(x, "tip.shape.by"))))))
}

#' @importFrom methods slot
.assign_viz_param <- function(args, x, element, aesthetic, arg.name = NULL) {
    # Build panel slot name
    slot_name <- paste(tolower(element), aesthetic, "by", sep = ".")
    # Use slot name if arg name is not given
    if( is.null(arg.name) ){
        arg.name <- slot_name
    }
    # Add slot value to args
    if( element %in% slot(x, paste(aesthetic, "parameters", sep = "_")) ){
        args[[arg.name]] <- deparse(slot(x, slot_name))
    }
    return(args)
}

test_that("RowTreePlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  panel <- RowTreePlot()
  
  panel[["layout"]] <- "rectangular"
  
  expect_identical(.getEncodedName(panel), "RowTreePlotNA")
  expect_identical(.fullName(panel), "Row tree plot")
  expect_identical(.panelColor(panel), "#4EEE94")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 2)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
      'p <- miaViz::plotRowTree(se, layout="rectangular", add.legend=TRUE,\n    order.tree=FALSE, open.angle=0)',
      fixed = TRUE)
  
  expect_true(.hideInterface(panel, "ColumnSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "column"))
  expect_true(.multiSelectionResponsive(panel, "row"))
  
  expect_contains(slotNames(panel), c("layout", "add.legend", "edge.colour.by",
      "tip.colour.by", "order.tree", "tip.size.by", "tip.shape.by",
      "edge.size.by", "node.size.by", "node.shape.by", "node.colour.by",
      "add.node.lab", "add.tip.lab", "branch.length", "open.angle",
      "rotate.angle"))
  
  expect_contains(.definePanelTour(panel)[[1]],
      c("#RowTreePlotNA_DataBoxOpen", "#RowTreePlotNA_VisualBoxOpen",
      "#RowTreePlotNA", "#RowTreePlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_tree(panel, tse), "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$RowTreePlotNA, "shiny.render.function")
  expect_s3_class(output$RowTreePlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$RowTreePlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
  expect_identical(.exportOutput(panel, tse), "RowTreePlotNA.pdf")
  
})

#' Row tree plot
#'
#' Hierarchical tree for the rows of a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' object. The tree can be produced with \code{\link[mia:taxonomy-methods]{addTaxonomyTree}}
#' and gets stored in the \code{\link[TreeSummarizedExperiment:rowLinks]{rowTree}}
#' slot of the experiment object. The panel implements \code{\link[miaViz:plotTree]{plotRowTree}}
#' to generate the plot.
#'
#' @section Slot overview:
#'
#' This class inherits all slots from its parent class \linkS4class{TreePlot}.
#'
#' @return
#' The \code{RowTreePlot(...)} constructor creates an instance of a RowTreePlot
#' class, where any slot and its value can be passed to \code{...} as a named
#' argument.
#'
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' # Store panel into object
#' panel <- RowTreePlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @seealso
#' \linkS4class{TreePlot}
#' \linkS4class{ColumnTreePlot}
#' 
#' @author Giulio Benedetti
#' 
#' @docType methods
#' @name RowTreePlot
NULL

#' @export
#' @importFrom methods new
RowTreePlot <- function(...) {
    new("RowTreePlot", ...)
}

setMethod(".fullName", "RowTreePlot", function(x) "Row tree plot")
setMethod(".panelColor", "RowTreePlot", function(x) "#4EEE94")

#' @importFrom methods slot callNextMethod
#' @importFrom TreeSummarizedExperiment rowTree
#' @importFrom ape Ntip
setMethod(".defineDataInterface", "RowTreePlot", function(x, se, select_info) {
  panel_name <- .getEncodedName(x)
  out <- callNextMethod()
  
  list(.selectInput.iSEE(x, field="collapse", label="Collapse nodes:",
          choices=seq_len(rowTree(se)$Nnode) + Ntip(rowTree(se)),
          multiple = TRUE, selected=slot(x, "collapse")), out)
})

#' @importFrom miaViz plotRowTree
#' @importFrom ggtree geom_tiplab collapse rotate_tree
#' @importFrom ggplot2 geom_text aes
#' @importFrom purrr reduce
setMethod(".generateOutput", "RowTreePlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)

    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )

    if( exists("row_selected", envir=panel_env, inherits=FALSE) ) {
        panel_env[["se"]] <- se[unlist(panel_env[["row_selected"]]), ]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["layout"]] <- deparse(slot(x, "layout"))
    args[["add.legend"]] <- deparse(slot(x, "add.legend"))
    args[["order.tree"]] <- deparse(slot(x, "order.tree"))
    args[["open.angle"]] <- deparse(slot(x, "open.angle"))
    
    if( slot(x, "branch.length") ){
        args[["branch.length"]] <- deparse("none")
    }
    
    if( "Colour" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Edge", "colour")
        args <- .assign_viz_param(args, x, "Node", "colour")
        args <- .assign_viz_param(args, x, "Tip", "colour")
    }
    
    if( "Shape" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Node", "shape")
        args <- .assign_viz_param(args, x, "Tip", "shape")
    }
    
    if( "Size" %in% slot(x, "visual_parameters") ){
        args <- .assign_viz_param(args, x, "Edge", "size")
        args <- .assign_viz_param(args, x, "Node", "size")
        args <- .assign_viz_param(args, x, "Tip", "size")
    }
  
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse = ", ")
    fun_call <- sprintf("p <- miaViz::plotRowTree(se, %s)", args)
    
    rotate_angle <- deparse(slot(x, "rotate.angle"))
    if( slot(x, "layout") != "rectangular" ){
        fun_call <- paste0(fun_call,
            sprintf("; p <- ggtree::rotate_tree(p, angle=%s)", rotate_angle))
    }

    if( slot(x, "add.tip.lab") ){
        fun_call <- paste0(fun_call, "; p <- p + geom_tiplab(size = 1)")
    }
    if( slot(x, "add.node.lab") ){
        fun_call <- paste0(fun_call,
            "; p <- p + geom_text(ggplot2::aes(label = node), hjust = -0.3, size = 2)")
    }
    
    nodes <- paste(slot(x, "collapse"), collapse = ", ")
    if( nodes != "NA" ){
        fun_call <- paste0(fun_call,
            sprintf(
                "; reduce(c(%s), function(x, y) collapse(x, y), .init = p)",
                nodes))
    }

    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd

    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "RowTreePlot", function(x, field) {
    
    if( field %in% c("SelectionHistory", "ColumnSelectionRestrict",
        "ColumnSelectionDynamicSource", "ColumnSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "RowTreePlot",
    function(x, dim = character(0)) {
    
    if( "row" %in% dim ){
        return(TRUE)
    }

    return(FALSE)
})

#' RDA plot
#'
#' CCA/RDA plot for the rows of a
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
#' object. The reduced dimension can be produced with \code{\link[mia:runCCA]{runRDA}}
#' and gets stored in the \code{\link[SingleCellExperiment:reducedDims]{reducedDim}}
#' slot of the experiment object. The panel implements \code{\link[miaViz:plotCCA]{plotRDA}}
#' to generate the plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualisation:
#' \itemize{
#' \item \code{add.ellipse}, a string specifying ellipse layout (filled, coloured or absent). 
#' \item \code{colour_by}, a string specifying the parameter to color by.
#' \item \code{add.vectors}, a logical indicating if vectors should appear in the plot.
#' \item \code{vec.text}, a logical indicating if text should be encased in a box.
#' \item \code{confidence.level}, a numeric between 0 and 1 to adjust confidence level.
#' \item \code{ellipse.alpha}, a numeric between 0 and 1 t o adjust ellipse opacity.
#' \item \code{ellipse.linewidth}, a numeric specifying the size of ellipses.
#' \item \code{ellipse.linetype}, a numeric specifying the style of ellipses.
#' \item \code{vec.size}, a numeric specifying the size of vectors.
#' \item \code{vec.colour}, a string specifying the colour of vectors.
#' \item \code{vec.linetype}, a numeric specifying the style of vector lines.
#' \item \code{arrow.size}, a numeric specifying the size of arrows.
#' \item \code{label.colour}, a string specifying the colour of text and labels.
#' \item \code{label.size}, a numeric specifying the size of text and labels. 
#' \item \code{add.significance}, a logical indicating if variance and p-value
#'  should appear in the labels.
#' \item \code{add.expl.var}, a logical indicating if variance should appear 
#'  on the coordinate axes.
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{RDAPlot(...)} constructor creates an instance of a RDAPlot class,
#' where any slot and its value can be passed to \code{...} as a named argument.
#'
#' @author Giulio Benedetti
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("enterotype", package = "mia")
#' tse <- enterotype
#'
#' # Run RDA and store results into TreeSE
#' tse <- addRDA(tse, assay.type = "counts",
#'               formula = assay ~ ClinicalStatus + Gender + Age,
#'               FUN = vegan::vegdist,
#'               distance = "bray",
#'               na.action = na.exclude)
#'
#' # Store panel into object
#' panel <- RDAPlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#'
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @docType methods
#' @name RDAPlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("RDAPlot", function(x) {
    msg <- character(0)
    
    msg <- .singleStringError(msg, x, fields=c("dimred", "colour_by",
        "vec.colour", "label.colour"))
    msg <- .validLogicalError(msg, x, fields=c("vec.text", "add.vectors",
        "add.significance", "add.expl.var"))
    msg <- .validNumberError(msg, x, "ellipse.alpha", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "confidence.level", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "ellipse.linewidth", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "ellipse.linetype", lower=1, upper=6)
    msg <- .validNumberError(msg, x, "vec.size", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "vec.linetype", lower=1, upper=6)
    msg <- .validNumberError(msg, x, "arrow.size", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "label.size", lower=0, upper=10)
    
    if( length(msg) ){
        return(msg)
    }
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "RDAPlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "dimred", "RDA")
    args <- .emptyDefault(args, "vec.colour", "black")
    args <- .emptyDefault(args, "label.colour", "black")
    args <- .emptyDefault(args, "add.ellipse", "fill")
    args <- .emptyDefault(args, "colour_by", NA_character_)
    args <- .emptyDefault(args, "add.vectors", TRUE)
    args <- .emptyDefault(args, "vec.text", TRUE)
    args <- .emptyDefault(args, "visual_parameters", NA_character_)
    args <- .emptyDefault(args, "add.expl.var", TRUE)
    args <- .emptyDefault(args, "add.significance", TRUE)
    args <- .emptyDefault(args, "ellipse.alpha", 0.2)
    args <- .emptyDefault(args, "confidence.level", 0.95)
    args <- .emptyDefault(args, "ellipse.linewidth", 0.1)
    args <- .emptyDefault(args, "ellipse.linetype", 1)
    args <- .emptyDefault(args, "vec.size", 0.5)
    args <- .emptyDefault(args, "vec.linetype", 1)
    args <- .emptyDefault(args, "arrow.size", 0.25)
    args <- .emptyDefault(args, "label.size", 4)
    
    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
RDAPlot <- function(...) {
    new("RDAPlot", ...)
}

#' @importFrom SingleCellExperiment reducedDimNames
#' @importFrom methods slot
setMethod(".defineDataInterface", "RDAPlot", function(x, se, select_info) {
    panel_name <- .getEncodedName(x)
    
    list(.selectInput.iSEE(x, field="dimred", label="Reduced dimension",
            choices=reducedDimNames(se), selected=slot(x, "dimred")),
        .sliderInput.iSEE(x, field="confidence.level", label="Confidence level",
            min = 0.90, max = 0.999, step= 0.001, value=slot(x, "confidence.level")),
        .checkboxInput.iSEE(x, field="add.significance", label="Show variance in labels",
            value=slot(x, "add.significance")),
        .checkboxInput.iSEE(x, field="add.expl.var", label="Show variance in axes",
            value=slot(x, "add.expl.var")))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "RDAPlot", function(x, se, select_info) {
    
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_rda(x, se), out[-1])
})

setMethod(".createObservers", "RDAPlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name, c("dimred",
        "confidence.level"), input=input, pObjects=pObjects, rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("add.ellipse",
        "colour_by", "vec.text", "add.vectors", "add.expl.var",
        "add.significance", "ellipse.alpha", "ellipse.linewidth",
        "ellipse.linetype", "vec.size", "vec.colour", "vec.linetype",
        "arrow.size", "label.colour", "label.size", "visual_parameters"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "RDAPlot", function(x) "RDA plot")
setMethod(".panelColor", "RDAPlot", function(x) "#CD5B45")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "RDAPlot", function(x) {
    panel_name <- .getEncodedName(x)
    
    addSpinner(plotOutput(panel_name,
        height = paste0(slot(x, "PanelHeight"), "px")), color=.panelColor(x))
})

#' @importFrom miaViz plotRowTree
setMethod(".generateOutput", "RDAPlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )
    
    if( is.null(panel_env[["col_selected"]]) ){
        panel_env[["se"]] <- se
    } else {
        panel_env[["se"]] <- se[ , unlist(panel_env[["col_selected"]])]
    }

    args[["dimred"]] <- deparse(slot(x, "dimred"))
    args[["colour_by"]] <- deparse(slot(x, "colour_by"))
    args[["confidence.level"]] <- deparse(slot(x, "confidence.level"))
    args[["add.expl.var"]] <- deparse(slot(x, "add.expl.var"))
    args[["add.significance"]] <- deparse(slot(x, "add.significance"))
    
    if( "Vector" %in% slot(x, "visual_parameters") ){
        args[["vec.size"]] <- deparse(slot(x, "vec.size"))
        args[["vec.colour"]] <- deparse(slot(x, "vec.colour"))
        args[["vec.linetype"]] <- deparse(slot(x, "vec.linetype"))
        args[["vec.text"]] <- deparse(slot(x, "vec.text"))
        args[["add.vectors"]] <- deparse(slot(x, "add.vectors"))
    }
    
    if( "Arrow" %in% slot(x, "visual_parameters") ){
        args[["arrow.size"]] <- deparse(slot(x, "arrow.size"))
    }
    
    if( "Ellipse" %in% slot(x, "visual_parameters") ){
        args[["ellipse.linewidth"]] <- deparse(slot(x, "ellipse.linewidth"))
        args[["ellipse.linetype"]] <- deparse(slot(x, "ellipse.linetype"))
        args[["ellipse.alpha"]] <- deparse(slot(x, "ellipse.alpha"))
        args[["add.ellipse"]] <- deparse(slot(x, "add.ellipse"))
    }
  
    if( "Label" %in% slot(x, "visual_parameters") ){
        args[["label.colour"]] <- deparse(slot(x, "label.colour"))
        args[["label.size"]] <- deparse(slot(x, "label.size"))
    }

    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotRDA(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
setMethod(".renderOutput", "RDAPlot",
    function(x, se, output, pObjects, rObjects) {
    
    panel_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[panel_name]] <- renderPlot({
        .retrieveOutput(panel_name, se, pObjects, rObjects)
    })

    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "RDAPlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "RDAPlot", function(x, field) {
    
    if( field %in% c("SelectionHistory", "RowSelectionRestrict",
        "RowSelectionDynamicSource", "RowSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "RDAPlot", function(x, dim = character(0)) {
    
    if( "column" %in% dim ){
        return(TRUE)
    }
    return(FALSE)
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "RDAPlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">RDA Plot</font> panel contains a representation
        of the correlation between variables of our dataset."
        , .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom SummarizedExperiment colData
#' @importFrom grDevices rainbow
#' @importFrom methods slot
.create_visual_box_for_rda <- function(x, se) {
    panel_name <- .getEncodedName(x)
    
    .addSpecificTour(class(x)[1], "dimred", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_dimred + .selectize-control"), intro = "Here, we can select the
            ordination method used.")))})
    .addSpecificTour(class(x)[1], "colour_by", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_colour_by + .selectize-control"), intro = "Here, we can select how
            colours are mapped on the plot.")))})
    .addSpecificTour(class(x)[1], "add.ellipse", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.ellipse + .selectize-control"), intro = "Here, we can choose
            whether or not to add an ellipse and adjust its style.")))})
    .addSpecificTour(class(x)[1], "add.vectors", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.vectors"), intro = "Here, we can choose
            whether or not to add vectors")))})
    .addSpecificTour(class(x)[1], "vec.text", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_vec\\.text"), intro = "Here, we can choose
            whether or not to add a box around labels.")))})
    .addSpecificTour(class(x)[1], "confidence.level", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_confidence\\.level"), intro = "Here, we can adjust
            the confidence level.")))})
    .addSpecificTour(class(x)[1], "ellipse.alpha", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_ellipse\\.alpha"), intro = "Here, we can choose
            the ellipse opacity.")))})
    .addSpecificTour(class(x)[1], "add.expl.var", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.expl\\.var"), intro = "Here, we can choose
            whether or not to to show the explained variance.")))})
    .addSpecificTour(class(x)[1], "add.significance", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_add\\.significance"), intro = "Here, we can choose
            whether or not to add variance in the axes.")))})
    .addSpecificTour(class(x)[1], "ellipse.linewidth", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_ellipse\\.linewidth"), intro = "Here, we can adjust
            the size of outline ellipses.")))})
    .addSpecificTour(class(x)[1], "ellipse.linetype", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_ellipse\\.linetype"), intro = "Here, we can adjust
            the style of outline ellipses.")))})
    .addSpecificTour(class(x)[1], "vec.size", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_vec\\.size"), intro = "Here, we can adjust
            the vectors thickness.")))})
    .addSpecificTour(class(x)[1], "vec.colour", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_vec\\.colour + .selectize-control"), intro = "Here, we can adjust
            the vectors colour.")))})
    .addSpecificTour(class(x)[1], "vec.linetype", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_vec\\.linetype"), intro = "Here, we can adjust
            the vectors style")))})
    .addSpecificTour(class(x)[1], "arrow.size", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_arrow\\.size"), intro = "Here, we can adjust
            the arrows size")))})
    .addSpecificTour(class(x)[1], "label.colour", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_label\\.colour + .selectize-control"), intro = "Here, we can adjust
            the labels colour")))})
    .addSpecificTour(class(x)[1], "label.size", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_label\\.size"), intro = "Here, we can adjust
            the labels size")))})
    .addSpecificTour(class(x)[1], "visual_parameters", function(panel_name) {
        data.frame(rbind(c(element = paste0("#", panel_name,
            "_visual_parameters"), intro = "Here, we can choose
            the visual parameters to adjust")))})
    
    # Define what parameters the user can adjust
    collapseBox(paste0(panel_name, "_Visual"),
        title="Visual parameters", open=FALSE,
        
        .checkboxGroupInput.iSEE(x, field="visual_parameters", label=NULL,
            inline=TRUE, selected=slot(x, "visual_parameters"),
            choices=c("Vector", "Arrow", "Ellipse", "Label")),
        .selectInput.iSEE(x, field="colour_by", label="Color by",
            choices=names(colData(se)), selected=slot(x, "colour_by")),
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Arrow",
                .sliderInput.iSEE(x, field="arrow.size", label="Arrows size",
                    min=0.01, max=0.99, step=0.01, value=slot(x, "arrow.size"))),
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Label",
            list(
                .selectInput.iSEE(x, field="label.colour", label="Labels colour",
                    choices=rainbow(7), selected=slot(x, "label.colour")),
                .sliderInput.iSEE(x, field="label.size", label="Labels size",
                    min=2.5, max=5.5, step=0.1, value=slot(x, "label.size")))),
        .conditionalOnCheckGroup(
          paste0(panel_name, "_visual_parameters"), "Ellipse",
          list(
              .selectInput.iSEE(x, field="add.ellipse", label="Ellipse style",
                  choices = c("fill", "colour", "FALSE"),
                  selected=slot(x, "add.ellipse")),
              .sliderInput.iSEE(x, field="ellipse.alpha", label="Ellipse opacity",
                  min=0.01, max=0.99, step=0.01, value=slot(x, "ellipse.alpha")),
              .sliderInput.iSEE(x, field="ellipse.linewidth", label="Ellipse outline size",
                  min=0.01, max=0.99, step=0.01, value=slot(x, "ellipse.linewidth")),
              .numericInput.iSEE(x, field="ellipse.linetype", label="Ellipse outline style",
                  value=slot(x, "ellipse.linetype"), min=1, max=6, step=1))),
        .conditionalOnCheckGroup(
            paste0(panel_name, "_visual_parameters"), "Vector",
            list(
                .checkboxInput.iSEE(x, field="add.vectors", label="Add vectors",
                    value=slot(x, "add.vectors")),
                .sliderInput.iSEE(x, field="vec.size", label="Vectors thickness",
                    min=0.01, max=0.99, step=0.01, value=slot(x, "vec.size")),
                .selectInput.iSEE(x, field="vec.colour", label="Vectors colour",
                    choices=rainbow(7), selected=slot(x, "vec.colour")),
                .numericInput.iSEE(x, field="vec.linetype", label="Vectors style",
                    value=slot(x, "vec.linetype"), min=1, max=6, step=1))),
        .conditionalOnCheckSolo(paste0(panel_name, "_add.vectors"), TRUE,
            .checkboxInput.iSEE(x, field="vec.text", label="Unboxed labels",
                value=slot(x, "vec.text"))))
}

test_that("RDAPlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("enterotype", package = "mia")
  tse <- enterotype
  panel <- RDAPlot()
  
  tse <- mia::runRDA(tse, assay.type = "counts",
      formula = assay ~ ClinicalStatus + Gender + Age,
      na.action = na.exclude)
  
  panel[["colour_by"]] <- "ClinicalStatus"

  expect_identical(.getEncodedName(panel), "RDAPlotNA")
  expect_identical(.fullName(panel), "RDA plot")
  expect_identical(.panelColor(panel), "#CD5B45")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 4)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
      "p <- miaViz::plotRDA(se, dimred=\"RDA\", colour_by=\"ClinicalStatus\",\n    confidence.level=0.95, add.expl.var=TRUE, add.significance=TRUE)",
      fixed = TRUE)
  
  expect_true(.hideInterface(panel, "RowSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "row"))
  expect_true(.multiSelectionResponsive(panel, "column"))
  
  expect_contains(slotNames(panel), c("dimred", "add.ellipse", "colour_by",
      "vec.text", "add.vectors", "ellipse.alpha", "confidence.level",
      "add.significance", "add.expl.var", "vec.size", "vec.colour",
      "vec.linetype", "arrow.size", "ellipse.linewidth",
      "ellipse.linetype", "label.colour", "label.size"))
  
  expect_contains(.definePanelTour(panel)[[1]],
      c("#RDAPlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_rda(panel, tse), "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$RDAPlotNA, "shiny.render.function")
  expect_s3_class(output$RDAPlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$RDAPlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
})

#' iSEE layout for TreeSE
#' 
#' Panel configuration tuned to the specific properties of
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}.
#' 
#' @inherit iSEE::iSEE params details sections
#' 
#' @return
#' The iSEE method for the TreeSE container returns a default set of panels
#' typically relevant for microbiome data. This configuration can be modified
#' by defining a different set of initial panels. By default, the interface
#' includes the following panels:
#' \itemize{
#' \item \code{RowDataTable()}
#' \item \code{ColumnDataTable()}
#' \item \code{RowTreePlot()}
#' \item \code{AbundancePlot()}
#' \item \code{AbundanceDensityPlot()}
#' \item \code{ReducedDimensionPlot()}
#' \item \code{ComplexHeatmapPlot()}
#' }
#'
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("GlobalPatterns", package = "mia")
#' tse <- GlobalPatterns
#'
#' # Agglomerate TreeSE by Genus
#' tse_genus <- agglomerateByRank(tse,
#'                                rank = "Genus",
#'                                onRankOnly = TRUE)
#'
#' # Add relabundance assay
#' tse_genus <- transformAssay(tse_genus, method = "relabundance")
#'
#' # Launch iSEE with custom initial panels
#' if (interactive()) {
#'   iSEE(tse_genus, initial = c(RowTreePlot(), AbundancePlot(), AbundanceDensityPlot()))
#' }
#' 
#' @docType methods
#' @aliases iSEE,TreeSummarizedExperiment-method
#' @name iSEE
NULL

#' @rdname iSEE
#' @export
setGeneric("iSEE", iSEE::iSEE)

#' @export
#' @importFrom iSEE createLandingPage ExperimentColorMap ReducedDimensionPlot
#'   ComplexHeatmapPlot RowDataTable ColumnDataTable
setMethod("iSEE", "TreeSummarizedExperiment",
    function(se, initial = c(RowDataTable(), ColumnDataTable(), RowTreePlot(),
        AbundancePlot(), AbundanceDensityPlot(), ReducedDimensionPlot(),
        ComplexHeatmapPlot()), extra = NULL, colormap = ExperimentColorMap(),
        landingPage = createLandingPage(), tour = NULL, appTitle = NULL,
        tabTitle = NULL, runLocal = TRUE, voice = FALSE, bugs = FALSE,
        saveState = NULL, ...) {
    
    initial <- .check_all_panels(se, initial)

    iSEE::iSEE(se, initial = initial, extra = initial, colormap = colormap,
        landingPage = landingPage, tour = tour, appTitle = appTitle,
        runLocal = runLocal, voice = voice, bugs = bugs,
        saveState = saveState, ...)
})

#' Prevalence plot
#'
#' Prevalence plot of all or agglomerated features in a
#' \code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
#' object. The panel implements \code{\link[miaViz:plotAbundance]{plotPrevalence}}
#' to generate the plot.
#'
#' @section Slot overview:
#' The following slots control the thresholds used in the visualization:
#' \itemize{
#' \item \code{detection} \code{Numeric scalar}. Detection threshold between 0
#'   and 1 for absence/presence. (Defualt: \code{0})
#' 
#' \item \code{prevalence} \code{Numeric scalar}. Prevalence threshold between 0
#'   and 1. The required prevalence is strictly greater by default. To
#'   include the limit, set \code{include.lowest} to \code{TRUE}. (Default:
#'   \code{0})
#' 
#' \item \code{assay.type} \code{Character scalar}. The name of the assay to
#'   show. (Default: \code{"relabundance"})
#' 
#' \item \code{rank} \code{Character scalar}. The taxonomic rank to visualise.
#'   (Default: \code{NULL})
#'  
#' \item \code{show.rank} \code{Logical scalar}. Should options for the
#'   taxonomic rank appear. (Default: \code{FALSE})
#'   
#' \item \code{include.lowest} \code{Logical scalar}. Should features with
#'   prevalence equal to \code{prevalence} be included. (Default: \code{FALSE})
#' }
#'
#' In addition, this class inherits all slots from its parent class
#' \code{\link[iSEE:Panel-class]{Panel}}.
#'
#' @return
#' The \code{PrevalencePlot(...)} constructor creates an instance of an
#' PrevalencePlot class, where any slot and its value can be passed to
#' \code{...} as a named argument.
#'
#' @author Giulio Benedetti
#' @examples
#' # Import TreeSE
#' library(mia)
#' data("Tengeler2020", package = "mia")
#' tse <- Tengeler2020
#' 
#' tse <- transformAssay(tse,
#'                       assay.type = "counts",
#'                       method = "relabundance")
#' 
#' # Store panel into object
#' panel <- PrevalencePlot()
#' # View some adjustable parameters
#' head(slotNames(panel))
#' 
#' # Launch iSEE with custom initial panel
#' if (interactive()) {
#'   iSEE(tse, initial = c(panel))
#' }
#' 
#' @docType methods
#' @name PrevalencePlot
NULL

#' @importFrom S4Vectors setValidity2
setValidity2("PrevalencePlot", function(x) {
    
    msg <- character(0)
    msg <- .singleStringError(msg, x, fields=c("assay.type", "rank"))
    msg <- .validLogicalError(msg, x, fields=c("include.lowest", "show.rank"))
    msg <- .validNumberError(msg, x, "detection", lower=0, upper=1)
    msg <- .validNumberError(msg, x, "prevalence", lower=0, upper=1)
    
    if( length(msg) ){
        return(msg)
    }
    TRUE
})

#' @importFrom methods callNextMethod
setMethod("initialize", "PrevalencePlot", function(.Object, ...) {
    args <- list(...)
    args <- .emptyDefault(args, "detection", 0)
    args <- .emptyDefault(args, "prevalence", 0)
    args <- .emptyDefault(args, "include.lowest", FALSE)
    args <- .emptyDefault(args, "assay.type", "relabundance")
    args <- .emptyDefault(args, "rank", NA_character_)
    args <- .emptyDefault(args, "show.rank", FALSE)

    do.call(callNextMethod, c(list(.Object), args))
})

#' @export
#' @importFrom methods new
PrevalencePlot <- function(...) {
    new("PrevalencePlot", ...)
}

#' @importFrom methods slot
#' @importFrom SummarizedExperiment assayNames
#' @importFrom mia taxonomyRanks
setMethod(".defineDataInterface", "PrevalencePlot", function(x, se, select_info) {
    panel_name <- .getEncodedName(x)
          
    list(.selectInput.iSEE(x, field="assay.type", label="Assay type:",
            choices=assayNames(se), selected=slot(x, "assay.type")),
        .sliderInput.iSEE(x, field="prevalence", label="Prevalence threshold:",
            min=0, max=1, step=0.01, value=slot(x, "prevalence")),
        .checkboxInput.iSEE(x, field="include.lowest", label="Include lowest",
            value=slot(x, "include.lowest")),
        .sliderInput.iSEE(x, field="detection", label="Detection threshold:",
            min=0, max=1, step=0.01, value=slot(x, "detection")),
        .checkboxInput.iSEE(x, field="show.rank", label="Show rank:",
            value=slot(x, "show.rank")),
        .conditionalOnCheckSolo(paste0(panel_name, "_show.rank"), TRUE,
            .selectInput.iSEE(x, field="rank", label="Rank",
            choices=taxonomyRanks(se), selected=slot(x, "rank"))))
})

#' @importFrom methods callNextMethod
setMethod(".defineInterface", "PrevalencePlot", function(x, se, select_info) {
    out <- callNextMethod()
    list(out[1], .create_visual_box_for_prev_plot(x, se), out[-1])
})

setMethod(".createObservers", "PrevalencePlot",
    function(x, se, input, session, pObjects, rObjects) {
    
    callNextMethod()
    panel_name <- .getEncodedName(x)
    
    .createProtectedParameterObservers(panel_name, c("assay.type", "prevalence",
        "detection", "include.lowest", "rank"), input=input, pObjects=pObjects,
        rObjects=rObjects)
    
    .createUnprotectedParameterObservers(panel_name, c("show.rank"),
        input=input, pObjects=pObjects, rObjects=rObjects)
    
    invisible(NULL)
})

setMethod(".fullName", "PrevalencePlot", function(x) "Prevalence plot")
setMethod(".panelColor", "PrevalencePlot", function(x) "grey")

#' @importFrom shiny plotOutput
#' @importFrom shinyWidgets addSpinner
setMethod(".defineOutput", "PrevalencePlot", function(x) {
    panel_name <- .getEncodedName(x)
    
    addSpinner(plotOutput(panel_name,
        height = paste0(slot(x, "PanelHeight"), "px")), color=.panelColor(x))
})

#' @importFrom miaViz plotPrevalence
setMethod(".generateOutput", "PrevalencePlot",
    function(x, se, all_memory, all_contents) {
    
    panel_env <- new.env()
    all_cmds <- list()
    args <- character(0)
    
    all_cmds[["select"]] <- .processMultiSelections(
        x, all_memory, all_contents, panel_env
    )
    
    if( exists("row_selected", envir=panel_env, inherits=FALSE) ){
        panel_env[["se"]] <- se[ , unlist(panel_env[["row_selected"]])]
    } else {
        panel_env[["se"]] <- se
    }
    
    args[["assay.type"]] <- deparse(slot(x, "assay.type"))
    args[["prevalence"]] <- deparse(seq(slot(x, "prevalence"), 1, by = 0.1))
    args[["detection"]] <- deparse(seq(slot(x, "detection"), 1, by = 0.1))
    args[["include.lowest"]] <- deparse(slot(x, "include.lowest"))
    
    if( slot(x, "show.rank") ){
        args[["rank"]] <- deparse(slot(x, "rank"))
    }
    
    args <- sprintf("%s=%s", names(args), args)
    args <- paste(args, collapse=", ")
    fun_call <- sprintf("p <- miaViz::plotPrevalence(se, %s)", args)
    
    fun_cmd <- paste(strwrap(fun_call, width = 80, exdent = 4), collapse = "\n")
    plot_out <- .textEval(fun_cmd, panel_env)
    all_cmds[["fun"]] <- fun_cmd
    
    list(commands=all_cmds, plot=plot_out, varname=NULL, contents=NULL)
})

#' @importFrom shiny renderPlot
#' @importFrom methods callNextMethod
setMethod(".renderOutput", "PrevalencePlot",
    function(x, se, output, pObjects, rObjects) {
    
    panel_name <- .getEncodedName(x)
    force(se) # defensive programming to avoid bugs due to delayed evaluation
    
    output[[panel_name]] <- renderPlot({
        .retrieveOutput(panel_name, se, pObjects, rObjects)
    })
    
    callNextMethod()
})

#' @importFrom grDevices pdf dev.off
setMethod(".exportOutput", "PrevalencePlot",
    function(x, se, all_memory, all_contents) {
            
    contents <- .generateOutput(x, se, all_memory=all_memory,
        all_contents=all_contents)
    
    newpath <- paste0(.getEncodedName(x), ".pdf")
            
    pdf(newpath, width=slot(x, "PanelHeight") / 75,
        height=slot(x, "PanelWidth") * 2)
    
    print(contents$plot)
    dev.off()
            
    newpath
})

#' @importFrom methods callNextMethod
setMethod(".hideInterface", "PrevalencePlot", function(x, field) {
    if( field %in% c("SelectionHistory", "ColumnSelectionRestrict",
        "ColumnSelectionDynamicSource", "ColumnSelectionSource") ){
        TRUE
    } else {
        callNextMethod()
    }
})

setMethod(".multiSelectionResponsive", "PrevalencePlot",
    function(x, dim = character(0)) {
    
    if( "row" %in% dim ){
        return(TRUE)
    }
    return(FALSE)
})

#' @importFrom methods callNextMethod
setMethod(".definePanelTour", "PrevalencePlot", function(x) {
    rbind(c(paste0("#", .getEncodedName(x)), sprintf(
        "The <font color=\"%s\">Prevalence Plot</font> panel
        contains a representation of the relative abundance
        for each taxonomic rank. Each column corresponds to
        a sample of the <code>SummarizedExperiment</code>
        object.", .getPanelColor(x))),
    .addTourStep(x, "DataBoxOpen", "The <i>Data parameters</i> box shows the
        available parameters that can be tweaked to control the data on
        the plot.<br/><br/><strong>Action:</strong> click on this
        box to open up available options."),
    .addTourStep(x, "Visual", "The <i>Visual parameters</i> box shows
        the available visual parameters that can be tweaked in this
        plot.<br/><br/><strong>Action:</strong> click on this box to
        open up available options."),
    callNextMethod())
})

#' @importFrom methods slot
#' @importFrom mia taxonomyRanks
#' @importFrom SummarizedExperiment rowData
.create_visual_box_for_prev_plot <- function(x, se) {
    panel_name <- .getEncodedName(x)

    # Define what parameters the user can adjust
    collapseBox(paste0(panel_name, "_Visual"),
        title="Visual parameters", open=FALSE)
}

test_that("PrevalencePlot", {
  
  output <- new.env()
  pObjects <- new.env()
  rObjects <- new.env()
  select_info <- list(single = list(feature = "---", sample = "---"),
                      multi = list(row = "---", column = "---"))
  
  data("Tengeler2020", package = "mia")
  tse <- Tengeler2020
  
  panel <- PrevalencePlot()
  
  panel[["include.lowest"]] <- TRUE
  
  expect_identical(.getEncodedName(panel), "PrevalencePlotNA")
  expect_identical(.fullName(panel), "Prevalence plot")
  expect_identical(.panelColor(panel), "grey")
  
  expect_s3_class(.defineInterface(panel, tse, select_info)[[1]][[1]], "shiny.tag.list")
  expect_length(.defineDataInterface(panel, tse, select_info), 6)
  
  expect_s3_class(.defineOutput(panel), "shiny.tag.list")
  # expect_match(.generateOutput(panel, tse)[["commands"]][["fun"]],
  #     'p <- miaViz::plotRowGraph(se, name=\"graph\", assay.type=\"counts\",\n    show.label=FALSE, layout=\"kk\", edge.type=\"fan\", add.legend=TRUE)',
  #     fixed = TRUE)
  
  expect_true(.hideInterface(panel, "ColumnSelectionSource"))
  expect_false(.multiSelectionResponsive(panel, "column"))
  expect_true(.multiSelectionResponsive(panel, "row"))
  
  expect_contains(slotNames(panel), c("detection", "prevalence", "assay.type",
      "rank", "include.lowest", "show.rank"))
  
  expect_contains(.definePanelTour(panel)[[1]],
      c("#PrevalencePlotNA_DataBoxOpen", "#PrevalencePlotNA",
      "#PrevalencePlotNA_SelectionBoxOpen"))
  
  expect_s3_class(.create_visual_box_for_prev_plot(panel, tse), "shiny.tag.list")
  
  expect_null(.renderOutput(panel, tse, output = output, pObjects = pObjects, rObjects = rObjects))
  expect_s3_class(output$PrevalencePlotNA, "shiny.render.function")
  expect_s3_class(output$PrevalencePlotNA_INTERNAL_PanelMultiSelectInfo, "shiny.render.function")
  expect_s3_class(output$PrevalencePlotNA_INTERNAL_PanelSelectLinkInfo, "shiny.render.function")
  
  # expect_identical(.exportOutput(panel, tse), "PrevalencePlotNA.pdf")
  
})

---
title: "Panel Catalogue"
author: 
  - name: Giulio Benedetti
    affiliation: University of Turku
    email: giulio.benedetti@utu.fi
output:
    BiocStyle::html_document:
        fig_height: 7
        fig_width: 10
        toc: true
        toc_float: true
        toc_depth: 2
        number_sections: true
        self_contained: true
        code_folding: show
date: "`r doc_date()`"
package: "`r pkg_ver('iSEEtree')`"
vignette: >
    %\VignetteIndexEntry{iSEEtree}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r screenfun, eval=!exists("SCREENSHOT"), include=FALSE}
SCREENSHOT <- function(x, ...) knitr::include_graphics(x)
```

# Introduction

This page introduces users to the complete catalogue of panels provided by
iSEEtree. Each panel is presented individually and visualised as it appears in
the app. This catalogue is divided into four sections:

- [compositional analysis](#sec-composition): abundance plot, abundance density
  plot, prevalence plot and complex heatmap plot
- [ordination analysis](#sec-ordination): RDA plot, Scree plot, loading plot and
  reduced dimension plot
- [structural analysis](#sec-structure): row/column tree plots and row/column
  graph plots
- [other](#sec-other): row/column tile plots, mediation plot and row/column data
  plots

# Compositional Analysis {#sec-composition}

| Panel name             | Panel class          | Information                         |
|------------------------|----------------------|-------------------------------------|
| Abundance plot         | AbundancePlot        | Feature abundance by sample         |
| Abundance density plot | AbundanceDensityPlot | Feature distribution across samples |
| Prevalence plot        | PrevalencePlot       | Feature prevalence across samples   |
| Feature assay plot     | FeatureAssayPlot     | Feature counts by column variable   |
| Complex heatmap plot   | ComplexHeatmapPlot   | Counts by features and samples      |

## Abundance plot

The Abundance plot illustrates the feature composition of each sample with a
barplot of the relative or absolute feature abundace. This panel is based on the
miaViz function plotAbundance.

Supported operations:

- Selecting taxonomic rank of the composition
- Choosing either absolute or relative abundance
- Ordering samples by feature or sample metadata
- Customising aesthetics

```{r abundance_density_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/AbundancePlot.png", delay=20)
```

## Abundance density plot

The Abundance density plot provides an alternative way to visualise abundance.
In this panel, each row represents the feature distribution across the samples.
It is based on the miaViz function plotAbundanceDensity.

Supported operations:

- selecting layout (jitter, density or dot plot)
- specifying the number of top features to show
- customising aesthetics

```{r abundance_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/AbundanceDensityPlot.png", delay=20)
```

## Prevalence plot

The Prevalence plot provides an way to visualise feature prevalence across
samples. In this panel, each line represents the feature abundance across the
samples and prevalence is encoded by the colour. It is based on the miaViz
function plotPrevalence.

Supported operations:

- adjusting prevalence and detection thresholds
- selecting the taxonomic rank to show

```{r prevalence_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/PrevalencePlot.png", delay=20)
```

## Feature assay plot

The Feature assay plot is inherited from iSEE. It is based on the
scater function plotRowData and can be used to visualise the counts of a
specific feature across samples grouped by a column variable.

See its image in the iSEE panel catalogue:
[FeatureAssayPlot](https://isee.github.io/panels.html#featureassayplot)

## Complex heatmap plot

The Reduced dimension plot is inherited from iSEE. It is based on the
ComplexHeatmap function Heatmap, which shows an entire assay as a heatmap where
rows and columns represent features and samples, respectively. Hierarchical
clustering as well as grouping by a variable can be performed across both
dimensions.

See its image in the iSEE panel catalogue:
[ComplexHeatmapPlot](https://isee.github.io/panels.html#complexheatmapplot)

# Ordination Analysis {#sec-ordination}

| Panel name             | Panel class          | Information                     |
|------------------------|----------------------|---------------------------------|
| RDA plot               | RDAPlot              | Supervised ordination           |
| Scree plot             | ScreePlot            | Explained variance by component |
| Loading plot           | LoadingPlot          | Feature loadings by component   |
| Reduced dimension plot | ReducedDimensionPlot | Any ordination result           |

## RDA plot

The RDA plot visualises results for a distance-based Redundance Analysis (dbRDA)
performed on a TreeSE object with the mia function runRDA. It is based on the
miaViz function plotRDA.

Supported operations:

- selecting reduced dimension
- adjusting statistical parameters
- customising aesthetics

```{r rda_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/RDAPlot.png", delay=20)
```

## Scree plot

The Scree plot shows the proportion of variance explained by each component
of a dimensionality reduction analysis by means of a line plot or barplot. It
is based on the miaViz function plotScree.

Supported operations:

- selecting reduced dimension
- changing number of components
- showing individual or cumulative variance
- adding components labels and names

```{r scree_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/ScreePlot.png", delay=20)
```

## Loading plot

The Loading plot visualises the contributions of each feature to the components
of a reduced dimension of choice. It is based on the miaViz function
plotLoadings.

Supported operations:

- selecting layout (barplot, heatmap or lollipop)
- changing number of components
- adding feature tree

```{r loading_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/LoadingPlot.png", delay=20)
```

## Reduced dimension plot

The Reduced dimension plot is inherited from iSEE. It is based on the
scater function plotReducedDim and can be used to visualise the results
of an ordination analysis with both supervised and unsupervised methods as dot
plot with reduced dimensions as coordinate axes.

See its image in the iSEE panel catalogue:
[ReducedDimensionPlot](https://isee.github.io/panels.html#reduceddimensionplot)

# Structural Analysis {#sec-structure}

| Panel name         | Panel class      | Information                        |
|--------------------|------------------|------------------------------------|
| Row tree plot      | RowTreePlot      | Hierarchical structure of features |
| Column tree plot   | ColumnTreePlot   | Hierarchical structure of samples  |
| Row graph plot     | RowGraphPlot     | Network structure of features      |
| Column graph plot  | ColumnGraphPlot  | Network structure of samples       |

## Row/Column tree plots

Row and column tree plots belong to the TreePlot family. They can be used to
visualise the hierarchical organisation of the features or samples by means
of a tree. They are based on the miaViz functions plotRowTree and plotColTree.

Supported operations:

- collapsing and expanding clades
- rotating and opening trees
- ordering trees
- labeling nodes and tips
- selecting tree layout
- customising aesthetics

```{r tree_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/RowTreePlot.png", delay=20)
```

## Row/Column graph plots

Row and column graph plots belong to the GraphPlot family. They can be used to
visualise the network organisation of the features or samples by means of a
graph. They are based on the miaViz functions plotRowGraph and plotColGraph.

Supported operations:

- selecting graph and assay type
- labelling nodes
- selecting graph layout
- selecting edge type
- customising aesthetics

```{r graph_plot, echo=FALSE, out.width="60%"}
SCREENSHOT("screenshots/RowGraphPlot.png", delay=20)
```

# Other panels {#sec-other}

| Panel name         | Panel class     | Information                                 |
|--------------------|-----------------|---------------------------------------------|
| Row tile plot      | RowTilePlot     | Variable distribution across feature groups |
| Column tile plot   | ColumnTilePlot  | Variable distribution across sample groups  |
| Mediation plot     | MediationPlot   | Results of mediation analysis               |
| Row data table     | RowDataTable    | Table of feature metadata                   |
| Column data table  | ColumnDataTable | Table of sample metadata                    |
| Row data plot      | RowDataPlot     | Feature variable distribution               |
| Column data plot   | ColumnDataPlot  | Sample variable distribution                |

## Row/Column tile plots

Coming soon!

## Mediation plot

Coming soon!

## Row/Column data tables

The Row and column data tables are inherited from iSEE. They are rendered as
a tidy table of feeature or sample variables, respectively. From those, it is
possible to select a subset of the observations and transmit it to one or many
other panels.

See their images in the iSEE panel catalogue:
[RowDataPlot](https://isee.github.io/panels.html#rowdataplot) and
[ColumnDataPlot](https://isee.github.io/panels.html#columndataplot)

## Row/Column data plots

The Row and column data plots are inherited from iSEE. They are based on the
scater functions plotRowData and plotColData and can be used to visualise
feature or sample metadata as scatter plots when the x variable is continuous or
boxplots when the x variable is discrete.

See their images in the iSEE panel catalogue:
[RowDataTable](https://isee.github.io/panels.html#rowdatatable) and
[ColumnDataTable](https://isee.github.io/panels.html#columndatatable)

# Reproducibility

R session information:

```{r reproduce, echo=FALSE}
## Session info
options(width = 120)
sessionInfo()
```

# References

---
title: "iSEEtree: interactive explorer for hierarchical data"
author: 
  - name: Giulio Benedetti
    affiliation: University of Turku
    email: giulio.benedetti@utu.fi
output:
    BiocStyle::html_document:
        fig_height: 7
        fig_width: 10
        toc: true
        toc_float: true
        toc_depth: 2
        number_sections: true
        self_contained: true
        code_folding: show
bibliography: ../inst/REFERENCES.bib
date: "`r doc_date()`"
package: "`r pkg_ver('iSEEtree')`"
vignette: >
    %\VignetteIndexEntry{iSEEtree}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

## Motivation

iSEEtree is a Bioconductor package for the interactive visualisation of
hierarchical data stored in a TreeSummarizedExperiment (TreeSE) container. On
the one side, it leverages and extends the graphics of the iSEE package, which
is designed for the generic SummarizedExperiment class. On the other side, it
employs the statistical and visual tools for microbiome data science provided by
the mia family of packages. Thus, iSEE and mia represent the two building blocks
of iSEEtree. Detailed introductory material on these two frameworks is available
in the [iSEE-verse website](https://isee.github.io/) and the
[OMA Bioconductor book](https://microbiome.github.io/OMA/docs/devel/),
respectively.

iSEEtree is meant for new and experienced users alike, who desire to create and
interact with several graphics for hierarchical data, without the need for an
in-depth knowledge of the underlying mia functionality. Current panels include
compositional plots, ordination graphs and structural tree or networks, which
are further discussed in the current article and in the
[online package documentation](https://microbiome.github.io/iSEEtree/).
Other more generic panels are also inherited from the parent package iSEE and
its many extensions.

## Panels

iSEEtree derives its microbiome-related visualisation methods from the
[miaViz](https://microbiome.github.io/miaViz/) package, which is code-based and
requires basic knowledge of R programming and microbiome data structures. The
panels provided represent an easy-to-use interactive version of most miaViz
plotting functions. They allow to visualise several aspects of hierarchical data
by three general approaches: compositional, ordination and structural analysis.

### Compositional Analysis

These panels can be used to explore sample composition and feature prevalence
or abundance across samples. This topic is further discussed in the OMA chapter
on [Community Composition](https://microbiome.github.io/OMA/docs/devel/pages/composition.html).

- [AbundancePlot](https://microbiome.github.io/iSEEtree/reference/AbundancePlot.html):
  a compositional barplot of the samples, where every bar is a sample composed
  by different features in different colours.
- [AbundanceDensityPlot](https://microbiome.github.io/iSEEtree/reference/AbundanceDensityPlot.html):
  a density plot of the top features, where every line is a feature and the x
  axis shows its abundance for different samples.
- PrevalencePlot: coming soon!

### Ordination Analysis

These panels show the results of ordination analyses or dimensionality reduction
methods applied to the assay data, both in terms of reduced components as well
as explained variance and feature importance. This topic is further discussed in
the OMA chapter on
[Community Similarity](https://microbiome.github.io/OMA/docs/devel/pages/20_beta_diversity.html).

- [RDAPlot](https://microbiome.github.io/iSEEtree/reference/RDAPlot.html): an
  supervised ordination plot of the samples, where every dot is a sample on a
  reduced dimensional space and every arrow reflects the contribution of a
  sample variable.
- [LoadingPlot](https://microbiome.github.io/iSEEtree/reference/LoadingPlot.html):
  a heatmap or barplot of the loadings or contributions of each feature to the
  reduced dimensions of PCA, PCoA or another ordination method.
- [ScreePlot](https://microbiome.github.io/iSEEtree/reference/LoadingPlot.html):
  a barplot of the contributions of each reduced dimension component to the
  explained variance.

### Structural Analysis

The structure or organisation of hierarchical data can be explored with the
tree and network visualisations that provide a holistic picture of the
structured relationships across features or samples. This topic is further
discussed in the OMA chapters on
[Exploration](https://microbiome.github.io/OMA/docs/devel/pages/quality_control.html) and
[Networks](https://microbiome.github.io/OMA/docs/devel/pages/network_learning.html).

- [RowTreePlot](https://microbiome.github.io/iSEEtree/reference/RowTreePlot.html):
  a phylogenetic tree of the features, where every tip is a feature and two
  neighbouring tips are more closely related than two far apart from each other.
- [ColumnTreePlot](https://microbiome.github.io/iSEEtree/reference/ColumnTreePlot.html):
  the hierarchical organisation of the samples, where every tip is a sample and
  the closer the more related they are.
- [RowGraphPlot](https://microbiome.github.io/iSEEtree/reference/RowGraphPlot.html):
  the network organisation of the features, where every node is a feature and
  edges reflect the degree of connection between features.
- [ColumnGraphPlot](https://microbiome.github.io/iSEEtree/reference/ColumnGraphPlot.html):
  the network organisation of the samples, where every node is a sample and
  edges reflect the degree of connection between samples.

### Other Panels

By default, the iSEEtree layout also includes the following panels inherited by
iSEE:

- [RowDataTable](https://isee.github.io/iSEE/articles/basic.html#row-data-tables)
- [ColumnDataTable](https://isee.github.io/iSEE/articles/basic.html#column-data-tables)
- [ReducedDimensionPlot](https://isee.github.io/iSEE/articles/basic.html#reduced-dimension-plots)
- [ComplexHeatmapPlot](https://isee.github.io/iSEE/articles/basic.html#heat-maps)

The [ColumnDataPlot](https://isee.github.io/iSEE/articles/basic.html#coldataplot)
could also prove useful for the visualisation of column variables such as
alpha diversity indices. Its interpretation is explained in the OMA chapter on
[Community Diversity](https://microbiome.github.io/OMA/docs/devel/pages/14_alpha_diversity.html).

For more information on the available panels, users are directed to the
[iSEEtree panel catalogue](https://microbiome.github.io/iSEEtree/articles/panels.html)
in the main package documentation.

# Tutorial

## Installation

R is an open-source statistical environment which can be easily modified to
enhance its functionality via packages. iSEEtree is an R package available on
[Bioconductor](https://bioconductor.org/). R can be installed on any operating
system from [CRAN](https://cran.r-project.org/) after which you can install
iSEEtree by using the following commands in your R session:

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("iSEEtree")
```

## Example

The panels described above can be generated for a model TreeSE object in the
following example:

```{r start, message=FALSE, warning=FALSE}
library(iSEEtree)
library(mia)
library(scater)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Add reduced dimensions
tse <- runMDS(tse, assay.type = "relabundance")

# Launch iSEE
if (interactive()) {
  iSEE(tse)
}
```

```{r screenfun, eval=!exists("SCREENSHOT"), include=FALSE}
SCREENSHOT <- function(x, ...) knitr::include_graphics(x)
```

```{r screenplot, echo=FALSE, out.width="100%"}
SCREENSHOT("screenshots/get_started.png", delay=20)
```

# Resources

## Open datasets

TreeSE objects can be constructed from raw data and standardised file formats.
However, several packages provide access to demonstration datasets used to
familiarise with the use of TreeSE objects. A complete list of resources is
available in the OMA chapter on
[Data Import](https://microbiome.github.io/OMA/docs/devel/pages/import.html#sec-example-data).

In addition, we provide the Microbiome Analysis Dashboard (miaDash), a web app
based on iSEEtree that offers a complete interface to import, analyse and
visualise microbiome data, or to easily access mia datasets for experimentation
purposes. The app is hosted online at
[this address](https://miadash-microbiome.2.rahtiapp.fi/) by the Finnish IT
Center for Science (CSC).

## Other tutorials

Users interested in general topics about the iSEE interface are redirected to
the [documentation](https://isee.github.io/iSEE) of the iSEE parent package,
which provides ideas and solutions on how to:

- use iSEE with big data
- configure iSEE apps
- deploy custom panels
- share information across panels
- control the interface with speech

## Citation

We hope that iSEEtree will be useful for your research. Please use the following
information to cite the package and the overall approach. Thank you!

```{r citation}
citation("iSEEtree")
```

## Acknowledgements

iSEEtree originates from the joint effort of the R/Bioconductor community. It is
mainly based on the following software:

- [R](https://www.r-project.org/), statistical programming language [@core2024r]
- [mia](https://bioconductor.org/packages/release/bioc/html/mia.html), framework for microbiome data analysis [@borman2024mia]
- [iSEE](https://bioconductor.org/packages/release/bioc/html/iSEE.html), SummarizedExperiment interactive explorer [@rue2018isee]
- [TreeSummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/TreeSummarizedExperiment.htmlm), S4 container for hierarchical data [@huang2021treesummarizedexperiment]
- [shiny](https://cran.r-project.org/web/packages/shiny/index.html), web app development in R [@chang2024shiny]

If you are asking yourself the question “Where do I start using Bioconductor?”
you might be interested in
[this blog post](https://lcolladotor.github.io/2014/10/16/startbioc/#.VkOKbq6rRuU).

## Help

As package developers, we try to explain clearly how to use our packages and in
which order to use the functions. But R and Bioconductor have a steep learning
curve so it is critical to learn where to ask for help. The blog post quoted
above mentions some but we would like to highlight the
[Bioconductor support site](https://support.bioconductor.org/) as the main
resource for getting help: remember to use the iSEEtree tag and check the
[older posts](https://support.bioconductor.org/t/iSEEtree/). Other alternatives
are available such as creating GitHub issues and tweeting. However, please note
that if you want to receive help you should adhere to the
[posting guidelines](https://www.bioconductor.org/help/support/posting-guide/).
It is particularly critical that you provide a small reproducible example and
your session information so package developers can track down the source of the
error.

# Reproducibility

R session information:

```{r reproduce, echo=FALSE}
## Session info
options(width = 120)
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iSEE-default.R
\docType{methods}
\name{iSEE}
\alias{iSEE}
\alias{iSEE,TreeSummarizedExperiment-method}
\title{iSEE layout for TreeSE}
\usage{
iSEE(
  se,
  initial = NULL,
  extra = NULL,
  colormap = ExperimentColorMap(),
  landingPage = createLandingPage(),
  tour = NULL,
  appTitle = NULL,
  tabTitle = NULL,
  runLocal = TRUE,
  voice = FALSE,
  bugs = FALSE,
  saveState = NULL,
  ...
)
}
\arguments{
\item{se}{A \linkS4class{SummarizedExperiment} object, ideally with named assays.
If missing, an app is launched with a landing page generated by the \code{landingPage} argument.}

\item{initial}{A list of \linkS4class{Panel} objects specifying the initial state of the app.
The order of panels determines the sequence in which they are laid out in the interface.
Defaults to one instance of each panel class available from \pkg{iSEE}.}

\item{extra}{A list of additional \linkS4class{Panel} objects that might be added after the app has started.
Defaults to one instance of each panel class available from \pkg{iSEE}.}

\item{colormap}{An \linkS4class{ExperimentColorMap} object that defines custom colormaps to apply to individual \code{assays}, \code{colData} and \code{rowData} covariates.}

\item{landingPage}{A function that renders a landing page when \code{iSEE} is started without any specified \code{se}.
Ignored if \code{se} is supplied.}

\item{tour}{A data.frame with the content of the interactive tour to be displayed after starting up the app.
Ignored if \code{se} is not supplied.}

\item{appTitle}{A string indicating the title to be displayed in the app.
If not provided, the app displays the version info of \code{\link[iSEE]{iSEE}}.}

\item{tabTitle}{A string indicating the title to be displayed in the browser
tab. If not provided, the tab is named \code{"iSEE"}.}

\item{runLocal}{A logical indicating whether the app is to be run locally or remotely on a server, which determines how documentation will be accessed.}

\item{voice}{A logical indicating whether the voice recognition should be enabled.}

\item{bugs}{Set to \code{TRUE} to enable the bugs Easter egg.
Alternatively, a named numeric vector control the respective number of each bug type (e.g., \code{c(bugs=3L, spiders=1L)}).}

\item{saveState}{A function that accepts a single argument containing the current application state and saves it to some appropriate location.}

\item{...}{Further arguments to pass to \code{\link{shinyApp}}.}
}
\value{
The iSEE method for the TreeSE container returns a default set of panels
typically relevant for microbiome data. This configuration can be modified
by defining a different set of initial panels. By default, the interface
includes the following panels:
\itemize{
\item \code{RowDataTable()}
\item \code{ColumnDataTable()}
\item \code{RowTreePlot()}
\item \code{AbundancePlot()}
\item \code{AbundanceDensityPlot()}
\item \code{ReducedDimensionPlot()}
\item \code{ComplexHeatmapPlot()}
}
}
\description{
Panel configuration tuned to the specific properties of
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}.
}
\details{
Configuring the initial state of the app is as easy as passing a list of \linkS4class{Panel} objects to \code{initial}.
Each element represents one panel and is typically constructed with a command like \code{\link[iSEE]{ReducedDimensionPlot}()}.
Panels are filled from left to right in a row-wise manner depending on the available width.
Each panel can be easily customized by modifying the parameters in each object.

The \code{extra} argument should specify \linkS4class{Panel} classes that might not be shown during initialization
but can be added interactively by the user after the app has started.
The first instance of each new class in \code{extra} will be used as a template when the user adds a new panel of that class.
Note that \code{initial} will automatically be appended to \code{extra} to form the final set of available panels,
so it is not strictly necessary to re-specify instances of those initial panels in \code{extra}.
(unless we want the parameters of newly created panels to be different from those at initialization).
}
\section{Setting up a tour}{


The \code{tour} argument allows users to specify a custom tour to walk their audience through various panels.
This is useful for describing different aspects of the dataset and highlighting interesting points in an interactive manner.

We use the format expected by the \code{rintrojs} package - see \url{https://github.com/carlganz/rintrojs#usage} for more information.
There should be two columns, \code{element} and \code{intro}, with the former describing the element to highlight and the latter providing some descriptive text. 
The \code{\link[iSEE]{defaultTour}} also provides the default tour that is used in the Examples below.

}

\section{Creating a landing page}{


If \code{se} is not supplied, a landing page is generated that allows users to upload their own RDS file to initialize the app.
By default, the maximum request size for file uploads defaults to 5MB
(\url{https://shiny.rstudio.com/reference/shiny/0.14/shiny-options.html}).
To raise the limit (e.g., 50MB), run \code{options(shiny.maxRequestSize=50*1024^2)}.

The \code{landingPage} argument can be used to alter the landing page, see \code{\link[iSEE]{createLandingPage}} for more details.
This is useful for creating front-ends that can retrieve \linkS4class{SummarizedExperiment}s from a database on demand for interactive visualization.

}

\section{Saving application state}{


If users want to record the application state, they can download an RDS file containing a list with the entries:
\itemize{
\item \code{memory}, a list of \linkS4class{Panel} objects containing the current state of the application.
This can be directly re-used as the \code{initial} argument in a subsequent \code{\link[iSEE]{iSEE}} call.
\item \code{se}, the \linkS4class{SummarizedExperiment} object of interest.
This is optional and may not be present in the list, depending on the user specifications.
\item \code{colormap}, the \linkS4class{ExperimentColorMap} object being used.
This is optional and may not be present in the list, depending on the user specifications.
}

We can also provide a custom function in \code{saveState} that accepts a single argument containing this list.
This is most useful when \code{\link[iSEE]{iSEE}} is deployed in an enterprise environment where sessions can be saved in a persistent location;
combined with a suitable \code{landingPage} specification, this allows users to easily reload sessions of interest.
The idea is very similar to Shiny bookmarks but is more customizable and can be used in conjunction with URL-based bookmarking.

}

\examples{
# Import TreeSE
library(mia)
data("GlobalPatterns", package = "mia")
tse <- GlobalPatterns

# Agglomerate TreeSE by Genus
tse_genus <- agglomerateByRank(tse,
                               rank = "Genus",
                               onRankOnly = TRUE)

# Add relabundance assay
tse_genus <- transformAssay(tse_genus, method = "relabundance")

# Launch iSEE with custom initial panels
if (interactive()) {
  iSEE(tse_genus, initial = c(RowTreePlot(), AbundancePlot(), AbundanceDensityPlot()))
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/family-TreePlot.R
\docType{class}
\name{TreePlot-class}
\alias{TreePlot-class}
\alias{TreePlot}
\title{Tree plot}
\description{
The TreePlot is a virtual class that creates a hierarchical tree of either
the features or samples of a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
object. The \linkS4class{RowTreePlot} and \linkS4class{ColumnTreePlot}
classes belong to this family and are specialised to visualise the rowTree
and the colTree, respectively.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{layout}: \code{Character scalar}. Tree layout.
(Default: \code{"fan"})
\item \code{add.legend}: \code{Logical scalar}. Should legend be shown.
(Default: \code{TRUE})
\item \code{edge.colour.by}: \code{Character scalar}. Parameter to colour
lines by when \code{colour_parameters = "Edge"}. (Default: \code{NULL})
\item \code{edge.size.by}: \code{Character scalar}. Parameter to size lines
by when \code{size_parameters = "Edge"}. (Default: \code{NULL})
\item \code{tip.colour.by}: \code{Character scalar}. Parameter to colour tips
by when \code{colour_parameters = "Tip"}. (Default: \code{NULL})
\item \code{tip.size.by}: \code{Character scalar}. Parameter to size tips by
when \code{size_parameters = "Tip"}. (Default: \code{NULL})
\item \code{tip.shape.by}: \code{Character scalar}. Parameter to shape tips
by when \code{shape_parameters = "Tip"}. (Default: \code{NULL})
\item \code{node.colour.by}: \code{Character scalar}. Parameter to colour
nodes by when \code{colour_parameters = "Node"}. (Default: \code{NULL})
\item \code{node.size.by}: \code{Character scalar}. Parameter to size nodes
by when \code{size_parameters = "Node"}. (Default: \code{NULL})
\item \code{node.shape.by}: \code{Character scalar}. Parameter to shape nodes
by when \code{shape_parameters = "Node"}. (Default: \code{NULL})
\item \code{order.tree}: \code{Logical scalar}. Should the tree be ordered
alphabetically by the taxonomic levels. (Default: \code{FALSE})
\item \code{open.angle}: \code{Numeric scalar}. Angle by which the tree is
opened when \code{layout} is \code{"fan"}. (Default: \code{0})
\item \code{rotate.angle}: \code{Numeric scalar}. Angle by which the tree is
rotated. (Default: \code{0})
\item \code{branch.length}: \code{Logical scalar}. Should branch length be
equalised. (Default: \code{FALSE})
}

In addition, this class inherits all slots from its parent
\code{\link[iSEE:Panel-class]{Panel}}.
}

\seealso{
\linkS4class{RowTreePlot}
\linkS4class{ColumnTreePlot}
}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iSEEtree-package.R
\docType{package}
\name{iSEEtree-package}
\alias{iSEEtree}
\alias{iSEEtree-package}
\title{iSEE extension for the TreeSummarizedExperiment container}
\description{
\code{iSEEtree} is an extension of \pkg{iSEE} that provides panels for the
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
container, enabling the interactive visualisation of typical microbiome data.
The panel layout of iSEEtree is described in \code{\link{iSEE}}.
}
\examples{
library(iSEEtree)

}
\seealso{
\link[iSEE:iSEE]{iSEE} \link[mia:mia]{mia}
}
\author{
Giulio Benedetti \email{giulio.benedetti@utu.fi}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-PrevalencePlot.R
\docType{class}
\name{PrevalencePlot-class}
\alias{PrevalencePlot-class}
\alias{PrevalencePlot}
\title{Prevalence plot}
\value{
The \code{PrevalencePlot(...)} constructor creates an instance of an
PrevalencePlot class, where any slot and its value can be passed to
\code{...} as a named argument.
}
\description{
Prevalence plot of all or agglomerated features in a
\code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
object. The panel implements \code{\link[miaViz:plotAbundance]{plotPrevalence}}
to generate the plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualization:
\itemize{
\item \code{detection} \code{Numeric scalar}. Detection threshold between 0
and 1 for absence/presence. (Defualt: \code{0})

\item \code{prevalence} \code{Numeric scalar}. Prevalence threshold between 0
and 1. The required prevalence is strictly greater by default. To
include the limit, set \code{include.lowest} to \code{TRUE}. (Default:
\code{0})

\item \code{assay.type} \code{Character scalar}. The name of the assay to
show. (Default: \code{"relabundance"})

\item \code{rank} \code{Character scalar}. The taxonomic rank to visualise.
(Default: \code{NULL})

\item \code{show.rank} \code{Logical scalar}. Should options for the
taxonomic rank appear. (Default: \code{FALSE})

\item \code{include.lowest} \code{Logical scalar}. Should features with
prevalence equal to \code{prevalence} be included. (Default: \code{FALSE})
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import TreeSE
library(mia)
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

tse <- transformAssay(tse,
                      assay.type = "counts",
                      method = "relabundance")

# Store panel into object
panel <- PrevalencePlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-AbundanceDensityPlot.R
\docType{class}
\name{AbundanceDensityPlot-class}
\alias{AbundanceDensityPlot-class}
\alias{AbundanceDensityPlot}
\title{Abundance density plot}
\value{
The \code{AbundanceDensityPlot(...)} constructor creates an instance of an
AbundanceDensityPlot class, where any slot and its value can be passed to
\code{...} as a named argument.
}
\description{
Density abundance profile of single features in a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}.
The panel implements \code{\link[miaViz:plotAbundanceDensity]{plotAbundanceDensity}}
to generate the plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{layout}, a string specifying abundance layout (jitter, density or points).
\item \code{assay.type}, a string specifying the assay to visualize.
\item \code{n}, a number indicating the number of top taxa to visualize.
\item \code{flipped}, a logical specifying if the axis should be switched.
\item \code{order_descending}, a string specifying the descending order.
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import TreeSE
library(mia)
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Store panel into object
panel <- AbundanceDensityPlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-AbundancePlot.R
\docType{class}
\name{AbundancePlot-class}
\alias{AbundancePlot-class}
\alias{AbundancePlot}
\title{Abundance plot}
\value{
The \code{AbundancePlot(...)} constructor creates an instance of an
AbundancePlot class, where any slot and its value can be passed to \code{...}
as a named argument.
}
\description{
Composite abundance profile of all features in a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
object. The panel implements \code{\link[miaViz:plotAbundance]{plotAbundance}}
to generate the plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualization:
\itemize{
\item \code{rank}, a string specifying the taxonomic rank to visualize.
\item \code{use_relative}, a logical indicating if the relative values should be calculated.
\item \code{add_legend}, a logical indicating if the color legend should appear.
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import TreeSE
library(mia)
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Store panel into object
panel <- AbundancePlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-ScreePlot.R
\docType{class}
\name{ScreePlot-class}
\alias{ScreePlot-class}
\alias{ScreePlot}
\title{Scree plot}
\value{
The \code{ScreePlot(...)} constructor creates an instance of an ScreePlot
class, where any slot and its value can be passed to \code{...} as a named
argument.
}
\description{
Contribution of each reduced dimension component to explained variance. The
reduced dimension should be stored in the
\code{\link[SingleCellExperiment:reducedDims]{reducedDim}} slot of a
\code{\link[SingleSummarizedExperiment:SingleSummarizedExperiment-class]{SingleSummarizedExperiment}}.
This panel uses \code{\link[miaViz:plotScree]{plotScree}} to generate the
plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{dimred} \code{Character scalar} or \code{integer scalar}.
Determines the reduced dimension to plot. This is used when \code{x} is a
\code{TreeSummarizedExperiment} to extract the eigenvalues from
\code{reducedDim(x, dimred)}.

\item \code{show.barplot}: \code{Logical scalar}. Whether to show a barplot.
(Default: \code{TRUE})

\item \code{show.points}: \code{Logical scalar}. Whether to show points.
(Default: \code{TRUE})

\item \code{show.line}: \code{Logical scalar}. Whether to show lines.
(Default: \code{TRUE})

\item \code{show.labels}: \code{Logical scalar}. Whether to show a label for
each point. (Default: \code{FALSE})

\item \code{add.proportion}: \code{Logical scalar}. Whether to show proportion of
explained variance, i.e., raw eigenvalues. (Default: \code{TRUE})

\item \code{add.cumulative}: \code{Logical scalar}. Whether to show cumulative
explained variance calculated from eigenvalues. (Default: \code{FALSE})

\item \code{n}: \code{Integer scalar}. Number of eigenvalues to plot. If
unspecified, all eigenvalues are plotted. (Default: \code{NULL})

\item \code{show.names}: \code{Logical scalar}. Whether to show names of the
components on the x-axis. If \code{FALSE}, indices are shown instead.
(Default: \code{FALSE})

\item \code{eig.name}: \code{Character scalar}. The name of the attribute in
\code{reducedDim(x, dimred)} that contains the eigenvalues.
(Default: \code{c("eig", "varExplained")})
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import libraries
library(mia)
library(scater)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Add reduced dimensions
tse <- runPCA(tse, assay.type = "relabundance")

# Store panel into object
panel <- ScreePlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\seealso{
\linkS4class{LoadingPlot}
\linkS4class{RDAPlot}
}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/family-GraphPlot.R
\docType{class}
\name{GraphPlot-class}
\alias{GraphPlot-class}
\alias{GraphPlot}
\title{Graph plot}
\description{
The Graph plot is a virtual class that showcases the network organisation of
either the features or samples of a
\code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
object. The \linkS4class{RowGraphPlot} and \linkS4class{ColumnGraphPlot}
classes belong to this family and are specialised to visualise the feature
or sample igraphs stored in metadata, respectively.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{name}: \code{Character scalar}. Metadata name containing graph.
(Default: \code{"graph"})
\item \code{assay.type}: \code{Character scalar}. Assay type to use.
(Default: \code{"counts"})
\item \code{layout}: \code{Character scalar}. Graph layout.
(Default: \code{"kk"})
\item \code{edge.type}: \code{Character scalar}. Edge type.
(Default: \code{"fan"})
\item \code{show.label}: \code{Logical scalar}. Should node labels be shown.
(Default: \code{FALSE})
\item \code{add.legend}: \code{Logical scalar}. Should legend be shown.
(Default: \code{TRUE})
\item \code{edge.colour.by}: \code{Character scalar}. Parameter to colour
lines by when \code{colour_parameters = "Edge"}. (Default: \code{NULL})
\item \code{edge.size.by}: \code{Character scalar}. Parameter to size lines
by when \code{size_parameters = "Edge"}. (Default: \code{NULL})
\item \code{node.colour.by}: \code{Character scalar}. Parameter to colour
nodes by when \code{colour_parameters = "Node"}. (Default: \code{NULL})
\item \code{node.size.by}: \code{Character scalar}. Parameter to size nodes
by when \code{size_parameters = "Node"}. (Default: \code{NULL})
\item \code{node.shape.by}: \code{Character scalar}. Parameter to shape nodes
by when \code{shape_parameters = "Node"}. (Default: \code{NULL})
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\seealso{
\linkS4class{RowGraphPlot}
\linkS4class{ColumnGraphPlot}
}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{utils}
\alias{utils}
\alias{.check_all_panels}
\alias{.check_panel}
\title{iSEEtree utils}
\usage{
.check_all_panels(se, initial)

.check_panel(se, initial, panel.class, panel.fun, wtext)
}
\arguments{
\item{se}{a
\code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
object.}

\item{initial}{\code{Panel vector}. A list of panel objects to check.}

\item{panel.class}{\code{Character vector}. A list of panel names
corresponding to panel objects in \code{initial}.}

\item{panel.fun}{\code{Function scalar}. The element of \code{se} whose
existence should be checked.}

\item{wtext}{\code{Character scalar}. Text of the warning message returned
if \code{panel.fun} does not exist or is empty.}
}
\value{
\code{.check_panel} returns the input \code{initial} list of panels excluding
the checked panel if \code{panel.fun} is \code{NULL} or empty.
\code{.check_all_panels} applies \code{.check_panel} to multiple panels and
returns the a filtered version of \code{initial}.
}
\description{
Utility functions to check the existence of specific elements in a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
that are compulsory when using certain panels.
}
\examples{
# Import libraries
library(mia)
library(TreeSummarizedExperiment)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Create list of panels
initial <- c(RowTreePlot(), ColumnTreePlot())
# If RowTreePlot is in initial, check whether rowLinks is defined
initial <- .check_panel(tse, initial, "RowTreePlot", rowLinks)
# If ColumnTreePlot is in initial, check whether colLinks is defined
initial <- .check_panel(tse, initial, "ColumnTreePlot", colLinks)

# View filtered list of panels
initial

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-LoadingPlot.R
\docType{class}
\name{LoadingPlot-class}
\alias{LoadingPlot-class}
\alias{LoadingPlot}
\title{Loading plot}
\value{
The \code{LoadingPlot(...)} constructor creates an instance of an
LoadingPlot class, where any slot and its value can be passed to
\code{...} as a named argument.
}
\description{
Contribution of single features in a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
to the components of a target reduced dimension. The panel implements
\code{\link[miaViz:plotLoadings]{plotLoadings}} to generate the plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{dimred}, a string specifying the dimred to visualize.
\item \code{layout}, a string specifying abundance layout (barplot or heatmap).
\item \code{ncomponents}, a number indicating the number of components to visualize.
\item \code{add.tree}, a logical indicating whether the tree should be shown.
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import libraries
library(mia)
library(scater)

# Import TreeSE
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Add relabundance assay
tse <- transformAssay(tse, method = "relabundance")

# Add reduced dimensions
tse <- runPCA(tse, assay.type = "relabundance")

# Store panel into object
panel <- LoadingPlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-ColumnTreePlot.R
\docType{class}
\name{ColumnTreePlot-class}
\alias{ColumnTreePlot-class}
\alias{ColumnTreePlot}
\title{Column tree plot}
\value{
The \code{ColumnTreePlot(...)} constructor creates an instance of a
ColumnTreePlot class, where any slot and its value can be passed to
\code{...} as a named argument.
}
\description{
Hierarchical tree for the columns of a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
object. The tree represents the sample hierarchy of the study and gets stored
in the \code{\link[TreeSummarizedExperiment:rowLinks]{colTree}} slot of the
experiment object. The panel implements \code{\link[miaViz:plotTree]{plotColTree}}
to generate the plot.
}
\section{Slot overview}{


This class inherits all slots from its parent class \linkS4class{TreePlot}.
}

\examples{
# Import TreeSE
library(mia)
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Store panel into object
panel <- ColumnTreePlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\seealso{
\linkS4class{TreePlot}
\linkS4class{RowTreePlot}
}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-ColumnGraphPlot.R
\docType{class}
\name{ColumnGraphPlot-class}
\alias{ColumnGraphPlot-class}
\alias{ColumnGraphPlot}
\title{Column graph plot}
\value{
The \code{ColumnGraphPlot(...)} constructor creates an instance of a
ColumnGraphPlot class, where any slot and its value can be passed to
\code{...} as a named argument.
}
\description{
Network organisation for the samples of a
\code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}
object. The igraph should be stored in the \code{metadata} slot by a name
containing \code{"graph"}. This panel uses
\code{\link[miaViz:plotColGraph]{plotColGraph}}
to generate the plot.
}
\section{Slot overview}{


This class inherits all slots from its parent class \linkS4class{GraphPlot}.
}

\examples{
library(mia)
library(miaViz)
data("GlobalPatterns", library = "mia")
data("col_graph", library = "miaViz")

tse <- GlobalPatterns
tse <- agglomerateByRank(tse,
                         rank = "Genus",
                         na.rm = TRUE)
                         
metadata(tse)$graph <- col_graph

# Store panel into object
panel <- ColumnGraphPlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\seealso{
\linkS4class{GraphPlot}
\linkS4class{RowGraphPlot}
}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-RDAPlot.R
\docType{class}
\name{RDAPlot-class}
\alias{RDAPlot-class}
\alias{RDAPlot}
\title{RDA plot}
\value{
The \code{RDAPlot(...)} constructor creates an instance of a RDAPlot class,
where any slot and its value can be passed to \code{...} as a named argument.
}
\description{
CCA/RDA plot for the rows of a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
object. The reduced dimension can be produced with \code{\link[mia:runCCA]{runRDA}}
and gets stored in the \code{\link[SingleCellExperiment:reducedDims]{reducedDim}}
slot of the experiment object. The panel implements \code{\link[miaViz:plotCCA]{plotRDA}}
to generate the plot.
}
\section{Slot overview}{

The following slots control the thresholds used in the visualisation:
\itemize{
\item \code{add.ellipse}, a string specifying ellipse layout (filled, coloured or absent).
\item \code{colour_by}, a string specifying the parameter to color by.
\item \code{add.vectors}, a logical indicating if vectors should appear in the plot.
\item \code{vec.text}, a logical indicating if text should be encased in a box.
\item \code{confidence.level}, a numeric between 0 and 1 to adjust confidence level.
\item \code{ellipse.alpha}, a numeric between 0 and 1 t o adjust ellipse opacity.
\item \code{ellipse.linewidth}, a numeric specifying the size of ellipses.
\item \code{ellipse.linetype}, a numeric specifying the style of ellipses.
\item \code{vec.size}, a numeric specifying the size of vectors.
\item \code{vec.colour}, a string specifying the colour of vectors.
\item \code{vec.linetype}, a numeric specifying the style of vector lines.
\item \code{arrow.size}, a numeric specifying the size of arrows.
\item \code{label.colour}, a string specifying the colour of text and labels.
\item \code{label.size}, a numeric specifying the size of text and labels.
\item \code{add.significance}, a logical indicating if variance and p-value
should appear in the labels.
\item \code{add.expl.var}, a logical indicating if variance should appear
on the coordinate axes.
}

In addition, this class inherits all slots from its parent class
\code{\link[iSEE:Panel-class]{Panel}}.
}

\examples{
# Import TreeSE
library(mia)
data("enterotype", package = "mia")
tse <- enterotype

# Run RDA and store results into TreeSE
tse <- addRDA(tse, assay.type = "counts",
              formula = assay ~ ClinicalStatus + Gender + Age,
              FUN = vegan::vegdist,
              distance = "bray",
              na.action = na.exclude)

# Store panel into object
panel <- RDAPlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\author{
Giulio Benedetti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/class-RowTreePlot.R
\docType{class}
\name{RowTreePlot-class}
\alias{RowTreePlot-class}
\alias{RowTreePlot}
\title{Row tree plot}
\value{
The \code{RowTreePlot(...)} constructor creates an instance of a RowTreePlot
class, where any slot and its value can be passed to \code{...} as a named
argument.
}
\description{
Hierarchical tree for the rows of a
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-constructor]{TreeSummarizedExperiment}}
object. The tree can be produced with \code{\link[mia:taxonomy-methods]{addTaxonomyTree}}
and gets stored in the \code{\link[TreeSummarizedExperiment:rowLinks]{rowTree}}
slot of the experiment object. The panel implements \code{\link[miaViz:plotTree]{plotRowTree}}
to generate the plot.
}
\section{Slot overview}{


This class inherits all slots from its parent class \linkS4class{TreePlot}.
}

\examples{
# Import TreeSE
library(mia)
data("Tengeler2020", package = "mia")
tse <- Tengeler2020

# Store panel into object
panel <- RowTreePlot()
# View some adjustable parameters
head(slotNames(panel))

# Launch iSEE with custom initial panel
if (interactive()) {
  iSEE(tse, initial = c(panel))
}

}
\seealso{
\linkS4class{TreePlot}
\linkS4class{ColumnTreePlot}
}
\author{
Giulio Benedetti
}
